{	
	( Textul dat de mine s-ar putea sa difere putin de cel initial,
	dar esenta este aceeasi; nu sunt sigur de numele fisierelor de 
	intrare	si iesire.   )
    3 (Inflorescenta). Se da un alfabet construit cu caractere ASCII
dintre care caracterul 'x' este un caracter special numit mugure.
Acest mugure poate fi rescris sau ca o anumita secventa de caractere din
alfabet sau ca orice alt caracter din alfabet. O secventa fara muguri obtinuta
dintr-un singur mugure dupa aplicarea unui numar nespecificat de reguli de
rescriere se numeste floare.
    Se cere sa se alcatuiasca un program care, dupa ce citeste de la intrare
o secventa de caractere ASCII, va decide daca ea este sau nu o floare.
    Structura datelor de intare se supune urmatoarelor reguli:
    a) Informatia despre alfabet se citeste dintr-un fisierul text '1.in';
acest fisier are structura:
secv_transformare
sir_testat

secv_transformare    ( al doilea test )
sir_testat
...

    Datele de iesire reprezinta mesaje scrise in fisierul '1.out' sub forma:
secventa sir_testat este o floare,   sau
secventa sir_testat nu este o floare
Exemplu: Sa presupunem ca fisierul de intrare are urmatorul continut:
axbxx
aacbadbsd

x+x
2+3+5

(x+x)
(q+w+e)

Fisierul de iesire va contine liniile:

Sirul aacbadbsd este o floare
Sirul 2+3+5 este o floare
Sirul (q+w+e) nu este o floare

}

{
    Problema se rezolva prin programare dinamica.
    Initial, se completeaza vectorul SECV si matricea B. Vectorul SECV
  pastreaza secventele de caractere dintre caracterele 'x' din sirul
  secv_transformare. Exemplu : pentru 'xabxc' obtinem SECV=('','ab','c').
    Matricea B contine 1 la B[i,j] daca SECV[j] se suprapune peste sirul
  testat incepand de la pozitia i.
    In matricea A[i,j], elementele au valoarea 1 daca secventa dintre
  pozitiile i si j ale sirului testat este o floare si 0 in caz contrar.
  La inceput A[i,i]=1 pentru orice i. Elementele matricei sunt completate
  in ordinea crescatoare a lungimii subsirurilor analizate (deci a diferentei
  j-i+1). Procedura VERIFY(x,y) completeaza A[x,y], pe baza pozitiilor
  completate anterior. Aceasta problema secundara este rezolvata tot prin
  programare dinamica.

    Fie S subsirul preluat de VERIFY (dat prin inceput si sfarsit). Se cunosc
  subsirurile lui S care pot fi obtinute fiecare dintr-un singur mugure. De
  asemenea, se cunoaste matricea B.
    Se completeaza matricea C; C[i,j]=1 daca s-a obtinut 'o parte dintr-un
  mugure', deci daca primele i caractere din S se suprapun peste primele j
  caractere din secv_transformare.
    Pentru (x+x)
        si (2+(3+5))
        avem :     c[1,1]=1 deoarece '('='('
    (de exemplu)   c[8,4]=1 deoarece '(2+'='(x+' si '(3+5)'='x'
                                                 (stiut din A[4,8])
    C[i,j] se obtine din elementele obtinute in partea din stanga sus a
  matricii C (relatiile de recurenta reies din program si difera datorita
  analizarii unei secvente fixe sau a unui mugure).
    Daca C[length(s),2*nr_caractere_x_din_secv_transformare+1]=1, atunci se
  returneaza 1 spre A[x,y].

    ( implementarea este putin diferita de metoda descrisa aici, dar
    foloseste aceeasi idee)

    Complexitatea este n^5.

}

var a,b,c:array[0..100,0..100]of byte;
    i,j,k,l,m,n,lung,nr:longint;
    fi,fo:text;
    s,text:string;
    secv:array[1..100]of string[100];

procedure readdata;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(secv,sizeof(secv),0);
  readln(fi,s);
  readln(fi,text);
  readln(fi);
end;

procedure verify(x,y:longint);
var i,j,k:longint;
begin
  if y-x+1<length(s)then exit;
  fillchar(c,sizeof(c),0);
  c[x-1,0]:=1;
  for i:=1 to n do
      c[i,0]:=1;
  for i:=x to y do
      begin
        for j:=1 to 2*nr-1 do
            case j mod 2 of
              0:begin
                  for k:=x to i-1 do
                      if c[i,j]=0 then
                         if (c[k,j-1]=1)and(a[k+1,i]=1) then
                            c[i,j]:=1;
                end;
              1:if length(secv[j div 2+1])=0 then
                   c[i,j]:=c[i,j-1]
                   else
                begin
                  if c[i-length(secv[j div 2+1]),j-1]=1 then
                     if b[i-length(secv[j div 2+1])+1,j div 2+1]=1 then
                        c[i,j]:=1;
                end;
            end;
      end;
  if c[y,2*nr-1]=1 then
     a[x,y]:=1;
end;

procedure solve;
begin
  { generarea vectorului SECV }

  nr:=1;
  i:=1;
  while i<=length(s)do
    begin
      secv[nr]:='';
      while (i<=length(s))and(s[i]<>'x') do
        begin
          secv[nr]:=secv[nr]+s[i];
          inc(i);
        end;
      inc(nr);
      inc(i);
    end;
  nr:=1;
  for i:=1 to length(s) do
      if s[i]='x' then inc(nr);

  { generarea matricii B }

  n:=length(text);
  for i:=1 to n do
      for j:=1 to nr do
          if (pos(secv[j],copy(text,i,n-i+1))=1)or(secv[j]='') then
             b[i,j]:=1;

  { dinamica }

  for i:=1 to n do
      a[i,i]:=1;

  for lung:=2 to n do
      begin
        for i:=1 to n-lung+1 do
            begin
              j:=i+lung-1;
              verify(i,j);
            end;
      end;
  if a[1,n]=1 then writeln(fo,'Sirul ',text,' este o floare')
              else writeln(fo,'Sirul ',text,' nu este o floare');

end;

begin
  assign(fi,'1.in');
  assign(fo,'1.out');
  reset(fi);
  rewrite(fo);
  while not seekeof(fi) do
    begin
      readdata;
      solve;
    end;
  close(fi);
  close(fo);
end.