{Problema 3 (Cap si stema):

Se da o matrice NxN (N<=10) de monezi, fiecare avand vizibila capul(H)
sau stema (T). Un jucator trebuie sa intoarca monezile, astfel ca in
final, toate sa fie cu stema in sus. Regula consta in aceea ca daca se
intoarce o moneda, atunci se intorc automat si toate monezile adiacente
(stanga, dreapta, sus, jos - daca exista).

Problema cere ca - plecand de la o configuratie initiala - sa se ajunga
la o matrice numai cu stema, efectuand un numar minim de "intoarceri".
Remarca: prin "intoarcere" se intelege: "se fixeaza o moneda si aceasta
se intoarce impreuna cu vecinele ei".

Intrare (fisier INPUT.TXT):
Prima linie contine numarul intreg N. Pe fiecare din urmatoarele N
linii se gasesc cate N caractere de forma H (cap) sau T (stema).

Iesire (fisier OUTPUT.TXT):
Prima linie va contine numarul minim de intoarceri. Urmatoarele N linii
reprezinta o matrice cu cate N numere intregi (0 sau 1) pe fiecare
linie. Valoarea 1 inseamna ca moneda a fost cel putin odata folosita
(pentru o intoarcere); valoarea 0 arata ca moneda de pe pozitia
respectiva nu a provocat nici o intoarcere.

Exemplu:
Intrare				Iesire:
3				5
H T T				1 0 0
H T T				0 1 0
T T T				1 1 1

Remarca: Se presupune ca problema are totdeauna solutie.

Timp maxim per test: 20 secunde.
Punctaj maxim: 40 puncte.
---------------------------------------
Branch  and bound: se construieste "pe nivele" arborele de solutii, algoritmul
oprindu-se cand se atinge un nod final (o pozitie cu toate monedele cu stema
in sus). Se tine cont de faptul ca nu are importanta ordinea de intoarcere a
monedelor si ca fiecare moneda poate fi intoarsa o singura data, o a doua
intoarcere a aceleiasi monede anuland efectul primei intoarceri.
Memorarea configuratiilor se face prin alocare dinamica, in lista adresata de
variabila u construindu-se configuratiile noi obtinute din configuratiile
memorate in lista adresata de variabila p la care se adauga o noua intoarcere.
}
{$m 3000,0,655000 $R+}
program cap_si_stema;
type tab=array[1..8,1..8]of boolean;
     adr=^nod;
     nod=record
               i,j:byte;
               t:tab;
               next:adr
         end;
var
    n,i,j,nivel:byte;
    ini:tab;p_ini,q,u_ini,r:adr;
    f,g:text;  ch:char;
function gata(x:tab):boolean;
var i,j,vec:byte;
begin
     gata:=false;
     for i:=1 to n do
         for j:=1 to n do begin
             vec:=byte(x[i,j]);
             if (i<n)and x[i+1,j] then inc(vec);
             if (i>1)and x[i-1,j] then inc(vec);
             if (j<n)and x[i,j+1] then inc(vec);
             if (j>1)and x[i,j-1] then inc(vec);
             if not(ini[i,j] xor odd(vec)) then exit
         end;
     gata:=true
end;

procedure scrie(q:adr);
var i,j:byte;
begin
     writeln(g,nivel);
     for i:=1 to n do begin
         for j:=1 to n do write(g,byte(q^.t[i,j]):2);
         writeln(g)
     end;
     close(g);halt
 end;

procedure intoarce;
var i,j:byte;
begin
     nivel:=nivel+1;
     q:=p_ini;u_ini:=nil;
     while q<>nil do begin
           for i:=1 to n do
               for j:=1 to n do
                   if ((i>q^.i)or(j>q^.j))and not q^.t[i,j] then begin
                      r:=u_ini;new(u_ini);
                      u_ini^:=q^;u_ini^.t[i,j]:=true;
                      u_ini^.i:=i;u_ini^.j:=j;
                      if gata(u_ini^.t) then scrie(u_ini);
                      u_ini^.next:=r
                   end;
           r:=q;q:=q^.next;
           dispose(r)
     end;
     p_ini:=u_ini;
     intoarce
end;
begin {program principal}
      assign(f,'input.txt');reset(f);
      assign(g,'output.txt');rewrite(g);
      readln(f,n);
      for i:=1 to n do begin
          for j:=1 to n do begin
              read(f,ch);
              while ch=' ' do read(f,ch);
              if ch='T' then ini[i,j]:=true;
          end;
          readln(f)
      end;
      new(p_ini);p_ini^.next:=nil;
      fillchar(p_ini^.t,100,false);
      p_ini^.i:=0;p_ini^.j:=0;
      nivel:=0;
      if gata(p_ini^.t) then scrie(p_ini);
      intoarce
end.