{Problema 2 (Sateliti)

Se preconizeaza lansarea pe orbita a unui grup de sateliti. Doi
sateliti pot transmite date de la unul la altul fie in mod direct, fie
indirect (adica prin intermediul altor sateliti intermediari); de asemenea
este posibil sa nu aiba nici o legatura. Spunem ca doi sateliti sunt vecini
numai daca ei pot transmite unul altuia date in mod direct.
	Fiind date un numar n si un set de n numere intregi, se cere:
a) Sa se stabileasca daca exista o configuratie de n sateliti astfel
incat setul de n numere citite la intrare sa corespunda vecinilor satelitilor;
b) Daca raspunsul la punctul (a) este YES, atunci descrieti o astfel de
configuratie;
c) Fiind data configuratia din (b), decideti daca se pot trimite date
de la oricare satelit la oricare altul.

Intrare (fisier INPUT.TXT):
Fisierul de intrare contine o singura linie pe care se afla o secventa
de numere intregi separate prin cate un spatiu. Primul numar, n<=20 da
numarul de sateliti de pe orbita. Urmatoarele n numere intregi
reprezinta numarul de vecini ai fiecarui satelit. Atentie! Ordinea
in care sunt date numerele vecinilor directi nu are nici o importanta.

Iesire (fisier OUTPUT.TXT):
Prima linie a fisierului de iesire contine raspunsul la punctul (a):
YES sau NO.
Daca raspunsul este NO, nu se mai cere altceva la iesire;
Daca raspunsul este YES, atunci urmeaza n linii, fiecare cu cate n
numere 0/1, separate prin cate un spatiu, formand o matrice nxn.
Satelitii i si j sunt vecini daca si numai daca al (i,j)-lea element
al matricii este 1.
A (n+2)-a linie a fisierului de iesire corespunde punctului (c) si este
un YES sau NO.

Exemplul 1:
Intrare:			Iesire:
6 4 3 1 4 2 0			NO

Exemplul 2:
Intrare:			Iesire:
7 4 3 1 5 4 2 1			YES
				0 1 1 1 1 1 0
				1 0 1 0 0 0 0
				1 1 0 1 0 1 0
				1 0 1 0 0 1 0
				1 0 0 0 0 0 0
				1 0 1 1 0 0 1
				0 0 0 0 0 1 0
				YES

Exemplul 3:
Intrare:			Iesire:
6 2 3 1 1 2 1			YES
				0 1 0 1 0 0
				1 0 1 1 0 0
				0 1 0 0 0 0
				1 1 0 0 0 0
				0 0 0 0 0 1
				0 0 0 0 1 0
				NO

Limita de timp per test: 20 secunde;
Punctaj maxim: 35 puncte
--------------------------------------
Datele de intrare reprezinta o secventa asupra careia trebuie sa se decida
daca este o secventa grafica (reprezinta gradele nodurilor unui graf):
-se ordoneaza sirul de numere d si, pe rand, se elimina primul numar din
secventa verificand daca acesta este <= cu numarul elemente ramase in
secventa, odata cu eliminarea decrementandu-se fiecare nr. din secventa ramasa.
-daca la fiecare pas este indeplinita conditia di<=n-i si ultimul numar din
secventa este 0, atunci sirul initial constituia o secventa grafica.
Pe masura ce se elimina numerele din sir se construieste si matricea de
adiacenta ceruta la punctul b).
Cerinta c) consta in determinarea proprietatii de conexitate a grafului si
propunem metoda marcarii recursive (in adancime) a nodurilor cu verificarea
finala a realizarii marcajului pentru toate nodurile din graf
}
program sateliti;
type nod=record
               id,deg:byte
         end;
var a:array[1..20,1..20]of byte;
    g:array[1..20]of nod;
    m:array[1..20]of boolean;
    n,i,j:byte; aux:nod;
    fi,fo:text; conex:boolean;
procedure marc(i:byte);
var j:byte;
begin
     m[i]:=true;
     for j:=1 to n do
         if (a[i,j]=1)and not m[j] then marc(j)
end;
procedure ordonare(i:byte);
{ordoneaza descrescator vectorul d intre pozitiile i si n}
var ordo:boolean;
begin
     repeat
           ordo:=true;
           for j:=i to n-1 do
               if g[j].deg<g[j+1].deg then begin
                  aux:=g[j];
                  g[j]:=g[j+1];
                  g[j+1]:=aux;
                  ordo:=false
               end
     until ordo
end;
begin
      assign(fi,'input.txt');reset(fi);
      assign(fo,'output.txt');rewrite(fo);
      read(fi,n);
      for i:=1 to n do begin
          read(fi,g[i].deg);
          g[i].id:=i
      end;
      close(fi);
      for i:=1 to n do begin
          ordonare(i);
          if g[i].deg>n-i then begin
             writeln(fo,'NO');
             close(fo);halt
          end else
                  for j:=i+1 to i+g[i].deg do begin
                      a[g[i].id,g[j].id]:=1;a[g[j].id,g[i].id]:=1;
                      dec(g[j].deg)
                  end
      end;
      writeln(fo,'YES');
      for i:=1 to n do begin
          for j:=1 to n do  write(fo,a[i,j]:2);
          writeln(fo);
      end;
      marc(1);
      conex:=true;
      for i:=1 to n do
          if not m[i] then begin
             conex:=false;
             break
          end;
      if conex then writeln(fo,'YES')
               else writeln(fo,'NO');
      close(fo)
end.