const
  fin = 'zad4.dat';
  fout = 'zad4.res';
  MaxN = 100000;

type
  TPoint = record
    x, y : Double;
  end;

  TCircle = record
    o : TPoint;
    r : Double;
  end;

var
  n : Cardinal;
  p : array[1..MaxN] of TPoint;
  MinCircle : TCircle;


  procedure ReadInput;
  var
    f : Text;
    i : Cardinal;
  begin
    Assign(f, fin);
    Reset(f);
    Readln(f, n);
    for i := 1 to n do
      Readln(f, p[i].x, p[i].y);
    Close(f);
  end;


  procedure WriteOutput;
  var
    f : Text;
  begin
    Assign(f, fout);
    Rewrite(f);
    Writeln(f, sqrt(MinCircle.r):0:10);
    Writeln(f, MinCircle.o.x:0:10, ' ', MinCircle.o.y:0:10);
    Close(f);
  end;


  procedure Solve;

    procedure MakeRandomPermutation;
    var
      i, j : Cardinal;
      temp : TPoint;
    begin
      Randomize;
      for i := n downto 1 do
      begin
        j := Random(n) + 1;
        temp := p[i];
        p[i] := p[j];
        p[j] := temp;
      end;
    end;

    function CircleWith2Points(a, b : TPoint) : TCircle;
    begin
      CircleWith2Points.o.x := (a.x + b.x) / 2;
      CircleWith2Points.o.y := (a.y + b.y) / 2;
      CircleWith2Points.r := (sqr(a.x - b.x) + sqr(a.y - b.y)) / 4
    end;

    procedure CircleWith3Points(a, b, c : TPoint);
    var
      sa, sb, sc, sba, scb, sac, s : Double;

    begin
      sa := sqr(a.x) + sqr(a.y);
      sb := sqr(b.x) + sqr(b.y);
      sc := sqr(c.x) + sqr(c.y);
      sba := sb - sa;
      scb := sc - sb;
      sac := sa - sc;
      s := (b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y);

      MinCircle.o.x := (a.y * scb + b.y * sac + c.y * sba) / (2 * s);
      MinCircle.o.y := (a.x * scb + b.x * sac + c.x * sba) / (2 * -s);
      MinCircle.r := sqr(MinCircle.o.x - a.x) + sqr(MinCircle.o.y - a.y);

    end;

    function PointInMinCircle(i : Cardinal) : Boolean;
    begin
      PointInMinCircle := sqr(p[i].x - MinCircle.o.x) +
                          sqr(p[i].y - MinCircle.o.y) <= MinCircle.r;
    end;

    procedure FindMin3(i, j : Cardinal);
    var
      k : Cardinal;
    begin
      MinCircle := CircleWith2Points(p[i], p[j]);
      for k := 1 to j - 1 do
        if not PointInMinCircle(k) then
          CircleWith3Points(p[i], p[j], p[k]);
    end;

    procedure FindMin2(i : Cardinal);
    var
      j : Cardinal;
    begin
      MinCircle := CircleWith2Points(p[1], p[i]);
      for j := 2 to i - 1 do
        if not PointInMinCircle(j) then
          FindMin3(i, j);
    end;

    procedure FindMin1;
    var
      i : Cardinal;
    begin
      MinCircle := CircleWith2Points(p[1], p[2]);
      for i := 3 to n do
        if not PointInMinCircle(i) then
          FindMin2(i);
    end;

  begin
    MakeRandomPermutation;
    FindMin1;
  end;


begin
  ReadInput;
  Solve;
  WriteOutput;
end.
