const maxN = 100; { Max. no of points }
      maxM = 30;  { Max. no of segments }
      maxD = 1000000.0;

type Point = record
               x,y : real;
             end;

var m,n : integer;
    p : array [1..maxN] of Point;
    tl,bl : array [1..maxM+1] of Point;
    td,bd : array [1..maxM] of real;
    ti,bi : array [1..maxM] of boolean;


    e : array [0..maxN+1, 0..maxN+1] of real;

    solution : real;

function crossPro(v1,v2 : Point) : real; { cross product }
  begin
    crossPro := v1.x*v2.y-v2.x*v1.y;
  end;

function scalPro(v1,v2 : Point) : real;  { scalar product }
  begin
    scalPro := v1.x*v2.x + v1.y*v2.y;
  end;

function max(a,b : real) : real;
  begin
    if a < b then max := b
    else max := a;
  end;

function min(a,b : real) : real;
  begin
    if a < b then min := a
    else min := b;
  end;

procedure readInput;
var f : text;
    i : integer;
    tmp1, tmp2 : Point;

  begin
    assign(f,'zad1.dat');
    reset(f);

    read(f,m);

    for i:=1 to m+1 do begin
      read(f,tl[i].x,tl[i].y);

      if (i > 2) then begin
        tmp1.x := tl[i].x - tl[i-2].x;
        tmp1.y := tl[i].y - tl[i-2].y;

        tmp2.x := tl[i-1].x - tl[i-2].x;
        tmp2.y := tl[i-1].y - tl[i-2].y;

        if crossPro(tmp1,tmp2) >= 0 then
          ti[i-1] := false
        else ti[i-1] := true;
      end;

      if (i > 1) then
        td[i-1] := max(abs(tl[i-1].x-tl[i].x), abs(tl[i-1].y-tl[i].y));
    end;

    for i:=1 to m+1 do begin
      read(f,bl[i].x,bl[i].y);

      if (i > 2) then begin
        tmp1.x := bl[i].x - bl[i-2].x;
        tmp1.y := bl[i].y - bl[i-2].y;

        tmp2.x := bl[i-1].x - bl[i-2].x;
        tmp2.y := bl[i-1].y - bl[i-2].y;

        if crossPro(tmp1,tmp2) > 0 then
          bi[i-1] := true
        else bi[i-1] := false;
      end;

      if (i > 1) then
        bd[i-1] := max(abs(bl[i-1].x-bl[i].x), abs(bl[i-1].y-bl[i].y));

    end;

    read(f,n);

    for i:=1 to n do
      read(f,p[i].x,p[i].y);

    close(f);
  end;

procedure createGraph; { e is the graph which will be created }
var i,j : integer;
    t1, t2 : Point;
    skalp : real;

  begin
    { Distance betwen top line and points }

    for i := 1 to n do begin
      e[0,i] := maxD;

      for j := 1 to m do begin
        t1.x := p[i].x - tl[j].x;
        t1.y := p[i].y - tl[j].y;

        t2.x := tl[j+1].x - tl[j].x;
        t2.y := tl[j+1].y - tl[j].y;

        if crossPro(t1,t2) <= 0 then continue;

        skalp := scalPro(t1,t2);
        skalp := skalp / td[j];
        if skalp < 0 then continue;


        if (not ti[j+1]) or (skalp <= td[j]) then begin
          if tl[j].x = tl[j+1].x then e[0,i] := min(e[0,i], abs(p[i].x-tl[j].x))
          else e[0,i] := min(e[0,i], abs(p[i].y-tl[j].y));

          continue;
        end;

        e[0,i] := min ( e[0,i],
                        max(  abs(p[i].x-tl[j+1].x), abs(p[i].y-tl[j+1].y))
                      );
      end;

    end;
    { Distance betwen points }

    for i := 1 to n-1 do
      for j:= i+1 to n do begin
        e[i,j] := max(abs(p[i].x-p[j].x), abs(p[i].y-p[j].y));
        e[j,i] := e[i,j];
      end;


    { Distance betwen bottom line and points }


    for i := 1 to n do begin
      e[i,n+1] := maxD;

      for j := 1 to m do begin
        t1.x := p[i].x - bl[j].x;
        t1.y := p[i].y - bl[j].y;

        t2.x := bl[j+1].x - bl[j].x;
        t2.y := bl[j+1].y - bl[j].y;

        if crossPro(t1,t2) >= 0 then continue;

        skalp := scalPro(t1,t2);
        skalp := skalp / bd[j];
        if skalp < 0 then continue;


        if (not bi[j+1]) or (skalp <= bd[j]) then begin
          if bl[j].x = bl[j+1].x then e[i,n+1] := min(e[i,n+1], abs(p[i].x-bl[j].x))
          else e[i,n+1] := min(e[i,n+1], abs(p[i].y-bl[j].y));

          continue;
        end;


        e[i,n+1] := min ( e[i,n+1],
                          max(  abs(p[i].x-bl[j+1].x), abs(p[i].y-bl[j+1].y))
                      );
      end;

    end;


    { Distance betwen lines }

    e[0,n+1] := abs(tl[1].x-bl[1].x)+abs(tl[1].y-bl[1].y);

    for i:=2 to m do
      e[0,n+1] := min ( e[0,n+1],
                        min ( abs(tl[i].x-bl[i].x),
                              abs(tl[i].y-bl[i].y)

                        )
                      );
  end;

procedure Dijkastra;
var us : array [0..maxN+1] of boolean;
    i,ind : integer;
    minr : real;

  begin
    solution := 0;

    for i:=0 to n+1 do us[i] := false;

    us[0] := true;
    while not us[n+1] do begin
      ind := -1;
      minr := maxD;

      for i:=n+1 downto 1 do { !!! optimisation }
        if (not us[i]) and (e[0,i] < minr) then begin
          ind := i;
          minr := e[0,i];
        end;

      us[ind] := true;
      solution := max(solution, minr);

      for i:=1 to n+1 do
        if (not us[i]) and (e[0,i] > e[ind,i]) then
          e[0,i] := e[ind,i];
    end;
  end;

procedure printSolution;
var i : integer;
    f : text;

  begin
{    for i:=1 to n do
      writeln(p[i].x:0:2,' ',p[i].y:0:2,' ',e[0,i]:0:2,' ',e[i,n+1]:0:2);


    writeln(e[0,n+1]:0:2);

    writeln('maxA = ',solution:0:0);}

    assign(f,'zad1.res');
    rewrite(f);

    writeln(f,solution:0:0);

    close(f);
  end;

begin
  readInput;

  createGraph;

  Dijkastra;

  printSolution;
end.
