/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/*
  Algoritm randomizat pentru determinarea unui ciclu de
  lungime K intr-un graf turneu, folosindu-se de algoritmul
  de determinare a unui drum hamiltonian intr-un graf turneu

  Punctaj obtinut pe testele de la BOI 2002 : 100p
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define maxvalue 50000
#define maxn 1001
#define filein "tour.in"
#define fileout "tour.out"

char edge[maxn][maxn],used[maxn];
long perm[maxn],path[maxn],cycle[maxn];
long i,j,k,m,n,poz,ntry,maxtry,oksol=0;

void read();
void compute();
void print();

int main()
{
read();
compute();
print();
return 0;
}

void read()
{
freopen(filein,"r",stdin);
scanf("%ld %ld",&n,&k);

memset(edge,0,sizeof(edge));
for (m=0;m<((n*(n-1))>>1);m++)
  {
  scanf("%ld %ld",&i,&j);
  edge[i][j]=1;
  }
}

void compute()
{
maxtry=maxvalue/n;

for (ntry=0;ntry<maxtry;ntry++)
  {
  srand(ntry*n/(ntry+7));

  memset(used,0,sizeof(used));
  for (i=1;i<=n;i++)
    {
    do
      {
      j=(rand()%n)+1;
      }
    while (used[j]);

    used[j]=1;
    perm[i]=j;
    }

  path[1]=perm[1];
  for (m=2;m<=n;m++)
    {
    i=perm[m];

    if (edge[path[m-1]][i])
      path[m]=i;
    else
    if (edge[i][path[1]])
      {
      for (j=m-1;j>=1;j--)
        path[j+1]=path[j];
      path[1]=i;
      }
    else
      {
      for (j=2;j<m;j++)
        if (edge[path[j-1]][i] && edge[i][path[j]])
          {
          poz=j; break;
          }

      for (j=m-1;j>=poz;j--)
        path[j+1]=path[j];
      path[poz]=i;
      }

    if (m>=k)
      {
      for (j=k;j<=m;j++)
        if (edge[path[j]][path[j-k+1]])
          {
          oksol=1;
          for (poz=j-k+1;poz<=j;poz++)
            cycle[poz-j+k]=path[poz];

          break;
          }
      }

    if (oksol) break;
    }

  if (oksol) break;
  }
}

void print()
{
freopen(fileout,"w",stdout);
if (!oksol)
  printf("0\n");
else
  {
  printf("%ld",cycle[1]);
  for (i=2;i<=k;i++)
    printf(" %ld",cycle[i]);

  printf("\n");
  }
}
