const
  fin = 'zad3.dat';
  fout = 'zad3.res';
  inf = 65000;
  MaxN = 1004;

type
  TLabel = (_s, _d, _n);

var
  n, len : Word;
  r : array[1..MaxN, 1..MaxN] of Boolean;
  InList, OutList : array[1..MaxN, 1..MaxN] of Word;
  InDeg, OutDeg : array[1..MaxN] of Word;

  CInDeg, COutDeg : array[1..MaxN] of Word;
  SList, DList, NList : array[1..MaxN] of Word;
  nS, nD, nN : Word;
  p : array[1..MaxN] of Word;
  SDN : array[1..MaxN] of TLabel;

  c : array[1..MaxN] of record
        v, next : Word;
      end;
  CLen : Word;
  VInC : array[1..MaxN] of boolean;

  SCC, SCCtemp : array[1..MaxN] of Word;
  nSCC : Word;


  procedure ReadInput;
  var
    f : Text;
    i : Longint;
    a, b : Word;
  begin
    Assign(f, fin);
    Reset(f);

    Readln(f, n, len);

    for a := 1 to n do
    begin
      InDeg[a] := 0;
      OutDeg[a] := 0;
    end;

    for i := 1 to (n * (n - 1)) div 2 do
    begin
      Readln(f, a, b);
      r[a, b] := true;
      r[b, a] := false;
      inc(OutDeg[a]);
      inc(InDeg[b]);
      OutList[a, OutDeg[a]] := b;
      InList[b, InDeg[b]] := a;
    end;

    Close(f);
  end;


  procedure FindSCC;
  var
    mark : array[1..MaxN] of Boolean;
    i, k : Word;
    f : array[1..MaxN] of Word;

    procedure DFS1(j : Word);
    var
      l : Word;
    begin
      mark[j] := true;
      for l := 1 to OutDeg[j] do
        if not mark[OutList[j, l]] then
          DFS1(OutList[j, l]);

      inc(k);
      f[k] := j;
    end;

    procedure DFS2(j : Word);
    var
      l : Word;
    begin
      inc(k);
      SCCtemp[k] := j;

      mark[j] := true;
      for l := 1 to InDeg[j] do
        if not mark[InList[j, l]] then
          DFS2(InList[j, l]);
    end;

  begin
    FillChar(mark, SizeOf(mark), false);
    k := 0;

    for i := 1 to n do
      if not mark[i] then DFS1(i);

    FillChar(mark, SizeOf(mark), false);

    for i := n downto 1 do
      if not mark[f[i]] then
      begin
        k := 0;
        DFS2(f[i]);
        if (k >= len) and (k < nSCC) then
        begin
          SCC := SCCtemp;
          nSCC := k;
        end;
      end;
  end;


  procedure ExtractSCC;
  var
    i, k, p : Word;
    InSCC : array[1..MaxN] of Boolean;
  begin
    FillChar(InSCC, SizeOf(InSCC), false);
    for i := 1 to nSCC do
      InSCC[SCC[i]] := true;

    for k := 1 to n do
      if InScc[k] then
      begin
        p := 0;
        for i := 1 to InDeg[k] do
          if InSCC[InList[k, i]] then
          begin
            inc(p);
            InList[k, p] := InList[k, i];
          end;
        InDeg[k] := p;

        p := 0;
        for i := 1 to OutDeg[k] do
          if InSCC[OutList[k, i]] then
          begin
            inc(p);
            OutList[k, p] := OutList[k, i];
          end;
        OutDeg[k] := p;
      end;
  end;


  procedure WriteOutput;
  var
    f : Text;
    i, j : Word;
  begin
    Assign(f, fout);
    Rewrite(f);

    if nSCC = inf then
      Writeln(f, 0)
    else
    begin
      j := 1;
      for i := 1 to len - 1 do
      begin
        Write(f, c[j].v, ' ');
        j := c[j].next;
      end;
      Writeln(f, c[j].v);
    end;

    Close(f);
  end;


  procedure Solve;

    procedure Init(k : Word);
    var
      i, j : Word;
    begin
      FillChar(VInC, SizeOf(VInC), false);
      c[1].v := k;
      c[1].next := 1;
      CLen := 1;
      VInC[k] := true;

      nS := 0;
      nD := 0;
      nN := 0;

      for i := 1 to InDeg[k] do
      begin
        j := InList[k, i];
        COutDeg[j] := 1;
        CInDeg[j] := 0;
        inc(nS);
        SList[nS] := j;
        p[j] := nS;
        SDN[j] := _s;
      end;

      for i := 1 to OutDeg[k] do
      begin
        j := OutList[k, i];
        CInDeg[j] := 1;
        COutDeg[j] := 0;
        inc(nD);
        DList[nD] := j;
        p[j] := nD;
        SDN[j] := _d;
      end;
    end;

    procedure AddToC(k, i : Word);
    var
      j, v, l : Word;
    begin
      VInC[k] := true;
      inc(CLen);
      c[CLen].v := k;
      c[CLen].next := c[i].next;
      c[i].next := CLen;

      case SDN[k] of
        _s : begin
               SList[p[k]] := SList[nS];
               dec(nS);
             end;
        _d : begin
               DList[p[k]] := DList[nD];
               dec(nD);
             end;
        _n : begin
               NList[p[k]] := NList[nN];
               dec(nN);
             end;
      end;

      for j := 1 to InDeg[k] do
      begin
        v := InList[k, j];
        if not VInC[v] then
        begin
          if SDN[v] = _d then
          begin;
            DList[p[v]] := DList[nD];
            dec(nD);
            inc(nN);
            NList[nN] := v;
            p[v] := nN;
            SDN[v] := _n;
          end;
          inc(COutDeg[v]);
        end;
      end;

      for j := 1 to OutDeg[k] do
      begin
        v := OutList[k, j];
        if not VInC[v] then
        begin
          if SDN[v] = _s then
          begin;
            SList[p[v]] := SList[nS];
            dec(nS);
            inc(nN);
            NList[nN] := v;
            p[v] := nN;
            SDN[v] := _n;
          end;
          inc(CInDeg[v]);
        end;
      end;
    end;

  var
    i, j, k, l : Word;

  begin
    nSCC := inf;
    FindSCC;
    if nSCC = inf then exit;
    ExtractSCC;

    Init(SCC[1]);

    while CLen < len do
    begin
      if nN > 0 then
      begin
        k := NList[nN];

        i := 1;
        while r[k, c[i].v] or r[c[c[i].next].v, k] do
          i := c[i].next;

        AddToC(k, i);
      end else
      begin
        for i := 1 to nD do
        begin
          k := DList[i];
          j := 1;
          while j <= OutDeg[k] do
          begin
            l := OutList[k, j];
            if (SDN[l] = _S) and r[k, l] then
              break;
            inc(j);
          end;
          if j <= OutDeg[k] then break;
        end;

        if CLen = len - 1 then
          c[1].next := c[2].next;

        AddToC(l, 1);
        AddToC(k, 1);
      end;
    end;
  end;


begin
  ReadInput;
  Solve;
  WriteOutput;
end.
