/* Ovidiu Gheorghioiu */

/* Score: 85 points */

#include <stdio.h>

#define NMAX 16000

int n, direct[NMAX+1][2], numDirect[NMAX+1], numIndirect[NMAX+1];
int stackEmployee[NMAX], stackSub[NMAX];
int company[NMAX+1];
int assigned[4];

void readData()
{
    FILE *f = fopen("firme.in", "rt");
    int i, employee, supervisor;

    fscanf(f, "%d", &n);


    for (i = 0; i<n-1; i++) {
	fscanf(f, "%d %d", &employee, &supervisor);
	direct[supervisor][numDirect[supervisor]] = employee;
	numDirect[supervisor] ++;
	/* verify testcase */
	if (numDirect[supervisor] > 2) {
	    printf("supervisor %d has more than 2 employees\n", supervisor);
	    exit(1);
	}
    }

    fclose(f);
}

void solve()
{
    int stackSize, i, j, employee, sub, sum, temp;
    int variant1, variant2, sub1, sub2;

#define push(empl,sub) { stackEmployee[stackSize] = (empl); stackSub[stackSize] = (sub); stackSize ++; }
#define pop(empl,sub) { stackSize --; (empl) = stackEmployee[stackSize]; (sub) = stackSub[stackSize]; }

    
    /* compute numIndirect */
    /* push GM */
    stackSize = 0; push(1,0);

    while(stackSize > 0) {
	pop(employee, sub);
	if (sub < numDirect[employee]) {
	    push(employee, sub+1);
	    push(direct[employee][sub], 0);
	} else {
	    /* count */
	    sum = 0;
	    for (j = 0; j<numDirect[employee]; j++) {
		sum += numIndirect[direct[employee][j]] + 1;
	    }
	    numIndirect[employee] = sum;
	}
    }

    printf("NumIndirect[1] = %d\n", numIndirect[1]);

    company[1] = 1; assigned[1] = 1;
    push(1,0);

    while (stackSize > 0) {
	pop(employee, sub);

	if (sub == 0 && numDirect[employee] > 0) {
	    /* decision making */
	    variant1 = company[employee] % 3 + 1;
	    variant2 = variant1 % 3 + 1;
	    /* variant1 has less assigned */
	    if (assigned[variant1] > assigned[variant2]) {
		temp = variant1; variant1 = variant2; variant2 = temp;
	    }

	    sub1 = direct[employee][0]; sub2 = direct[employee][1];
	    /* sub2 can be 0 */

	    /* assign variant1 to the first employee if alone, or has
	     * less direct than second employee */
	    if (sub2 == 0 || numDirect[sub1] < numDirect[sub2]) {
		company[sub1] = variant1; assigned[variant1] ++;
		printf("Assigned %d to %d and %d to %d\n",
		       variant1, sub1, variant2, sub2);
		if (sub2 != 0) {
		    company[sub2] = variant2; assigned[variant2]++;
		}
	    } else {
		printf("Assigned %d to %d and %d to %d\n",
		       variant2, sub1, variant1, sub2);
		company[sub1] = variant2; assigned[variant2] ++;
		company[sub2] = variant1; assigned[variant1] ++;
	    }
	}

	/* descend */
	if (sub < numDirect[employee]) {
	    push(employee, sub+1);
	    push(direct[employee][sub], 0);
	}
    }

    printf("num assigned: %d %d %d\n", assigned[1], assigned[2], assigned[3]);
}

void writeData()
{
    FILE *f = fopen("firme.out", "wt");
    int i;
    
    for (i = 0; i < n; i++) {
	fprintf(f, "%d ", company[i+1]);
    }
}


int main()
{
    readData();
    solve();
    writeData();

    return 0;
}
