/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* Time Complexity: O(N*logN) */

/* Score: 60 points (TLE on 40% of the test cases) */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define filein "travers.in"
#define fileout "travers.out"
#define maxn 100001
#define P 9901

typedef struct { long li,ls,fs,fd,tata,sum; } nod;

long he[maxn],hsort[maxn],haux[maxn],list[maxn];
long i,j,k,m,n,nd,hmax,narb,total;
nod arb[2*maxn+1];

void readdata(void);
void precompute(void);
void buildtree(void);
void compute(void);
void writedata(void);

int main()
{
readdata();
precompute();
buildtree();
compute();
writedata();
return 0;
}

void readdata(void)
{
long i;

freopen(filein,"r",stdin);

scanf("%ld %ld",&n,&hmax);
for (i=1;i<=n;i++)
  {
  scanf("%ld",&he[i]);
  hsort[i]=he[i];
  }
}

void sort(long li,long ls)
{
if (ls-li==1)
  {
  if (hsort[li]>hsort[ls])
    {
    k=hsort[li]; hsort[li]=hsort[ls]; hsort[ls]=k;
    }
  }
else
if (ls-li>1)
  {
  sort(li,(li+ls)>>1);
  sort(((li+ls)>>1)+1,ls);

  k=li-1;
  i=li;
  m=(li+ls)>>1;
  j=m+1;

  while (i<=m && j<=ls)
    {
    k++;

    if (hsort[i]<hsort[j])
      {
      haux[k]=hsort[i];
      i++;
      }
    else
      {
      haux[k]=hsort[j];
      j++;
      }
    }

  if (i<=m)
    {
    for (j=i;j<=m;j++)
      {
      k++;
      haux[k]=hsort[j];
      }
    }
  else
    {
    for (i=j;i<=ls;i++)
      {
      k++;
      haux[k]=hsort[i];
      }
    }

  for (k=li;k<=ls;k++)
    hsort[k]=haux[k];
  }
}

void precompute(void)
{
sort(1,n);

for (nd=1,i=2;i<=n;i++)
  if (hsort[i]>hsort[i-1])
    {
    nd++;
    hsort[nd]=hsort[i];
    }
}

void buildtree(void)
{
long i,j,k,p;

for (i=1;i<=nd;i++)
  {
  arb[i].li=arb[i].ls=list[i]=i;
  arb[i].fs=arb[i].fd=arb[i].tata=0;
  }
  
k=narb=nd;
while (k>1)
  {
  j=0;
  for (i=1;i<k;i++)
    if (i%2==1)
      {
      narb++;
      arb[narb].li=arb[list[i]].li;
      arb[narb].ls=arb[list[i+1]].ls;
      arb[narb].fs=list[i];
      arb[narb].fd=list[i+1];
      arb[list[i]].tata=narb;
      arb[list[i+1]].tata=narb;
      arb[narb].tata=0;
      j++;
      list[j]=narb;
      }

  if (k%2==1)
    {
    j++;
    list[j]=list[k];
    }

  k=j;
  }
}

long locatelow(long x)
{
long poz,li,ls,m;

li=1; ls=nd; poz=n;
while (li<=ls)
  {
  m=(li+ls)>>1;

  if (hsort[m]<x)
    li=m+1;
  else
    {
    poz=m;
    ls=m-1;
    }
  }

return poz;
}

long locatehigh(long x)
{
long poz,li,ls,m;

li=1; ls=nd; poz=1;
while (li<=ls)
  {
  m=(li+ls)>>1;

  if (hsort[m]<=x)
    {
    poz=m;
    li=m+1;
    }
  else
    ls=m-1;
  }

return poz;
}

long getsum(long li,long ls,long num)
{
long fs,fd,ss,sd;

fs=arb[num].fs;
fd=arb[num].fd;

if (li==arb[num].li && ls==arb[num].ls)
  return arb[num].sum;
else
if (li==arb[num].li)
  {
  if (arb[fd].li<=ls)
    {
    ss=getsum(li,arb[fs].ls,fs);
    sd=getsum(arb[fd].li,ls,fd);
    }
  else
    {
    ss=getsum(li,ls,fs);
    sd=0;
    }
  }
else
if (ls==arb[num].ls)
  {
  if (arb[fs].ls>=li)
    {
    ss=getsum(li,arb[fs].ls,fs);
    sd=getsum(arb[fd].li,ls,fd);
    }
  else
    {
    ss=0;
    sd=getsum(li,ls,fd);
    }
  }
else
  {
  if (ls<=arb[fs].ls)
    {
    ss=getsum(li,ls,fs);
    sd=0;
    }
  else
  if (li>=arb[fd].li)
    {
    ss=0;
    sd=getsum(li,ls,fd);
    }
  else
    {
    ss=getsum(li,arb[fs].ls,fs);
    sd=getsum(arb[fd].li,ls,fd);
    }
  }

return (ss+sd);
}

void addtotree(long num,long x)
{
while (num!=0)
  {
  arb[num].sum=(arb[num].sum+x)%P;
  num=arb[num].tata;
  }
}

void compute(void)
{
long i,npos,p1,p2;

/* initialize the tree */
for (i=1;i<=narb;i++)
  arb[i].sum=0;

for (total=0,i=1;i<=n;i++)
  {
  p1=locatelow(he[i]-hmax);
  p2=locatehigh(he[i]+hmax);

  npos=getsum(p1,p2,narb);
  total=(total+npos)%P;
  npos=(npos+1)%P;
  addtotree(locatelow(he[i]),npos);
  }
}

void writedata(void)
{
freopen(fileout,"w",stdout);
printf("%ld\n",total);
}
