/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* Time Complexity: O(N*logN) */

/* Score: 100 points */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define filein "tribe.in"
#define fileout "tribe.out"
#define maxn 100002
#define maxcol 21

typedef struct nod { long x; nod* urm; } NOD;

NOD *edge[maxn],*aux;
long tata[maxn],c[maxn],cmax[maxn],cols[maxn][maxcol];
long n;

void read();
void compute();
void print();

int main()
{
read();
compute();
print();
return 0;
}

void read()
{
long i,j,k;

freopen(filein,"r",stdin);
scanf("%ld",&n);

for (i=1;i<=n;i++)
  edge[i]=NULL;

for (k=1;k<n;k++)
  {
  scanf("%ld %ld",&i,&j);

  aux=new NOD;
  aux->x=j;
  aux->urm=edge[i];
  edge[i]=aux;

  aux=new NOD;
  aux->x=i;
  aux->urm=edge[j];
  edge[j]=aux;
  }
}

void df1(long v)
{
NOD *aux=edge[v];
long i,left,max=0;

/* part 1 */
while (aux!=NULL)
  {
  i=aux->x;
  if (tata[i]==0)
    {
    tata[i]=v;
    df1(i);
    }
  aux=aux->urm;
  }

/* part 2 */
memset(cols[v],0,sizeof(cols[v]));
cols[v][0]=1;
aux=edge[v];
while (aux!=NULL)
  {
  i=aux->x;
  if (tata[i]==v)
    cols[v][c[i]]++;
  aux=aux->urm;
  }

/* find c[v] */
max=maxcol;
for (left=0,i=maxcol-1;i>=0;i--)
  {
  left+=cols[v][i];

  if (left>0)
    left--;
  else
    max--;
  }

c[v]=max;
}

void df2(long v)
{
NOD *aux;
long i,left,max;

if (tata[v]>0)
  {
  /* recompute c[tata[v]] without considering v as his son */
  cols[tata[v]][c[v]]--;
  max=maxcol;
  for (left=0,i=maxcol-1;i>=0;i--)
    {
    left+=cols[tata[v]][i];
  
    if (left>0)
      left--;
    else
      max--;
    }
  cols[tata[v]][c[v]]++; /* restore the cols array for tata[v] */
  /* at this point, max = the new c[tata[v]] */

  /* compute cmax[v] */
  memset(cols[v],0,sizeof(cols[v]));
  cols[v][0]=cols[v][max]=1;
  aux=edge[v];
  while (aux!=NULL)
    {
    i=aux->x;
    if (tata[i]==v)
      cols[v][c[i]]++;
    aux=aux->urm;
    }
  
  max=maxcol;
  for (left=0,i=maxcol-1;i>=0;i--)
    {
    left+=cols[v][i];
  
    if (left>0)
      left--;
    else
      max--;
    }
  
  cmax[v]=max;
  }

aux=edge[v];
while (aux!=NULL)
  {
  i=aux->x;
  if (tata[i]==v)
    df2(i);
  aux=aux->urm;
  }
}

void compute()
{
memset(tata,0,sizeof(tata));
memset(cmax,0,sizeof(cmax));
memset(c,0,sizeof(c));
tata[1]=-1;
df1(1);

cmax[1]=c[1];
df2(1);
}

void print()
{
long i,root,max=0;

freopen(fileout,"w",stdout);
for (i=1;i<=n;i++)
  if (cmax[i]>max)
    {
    max=cmax[i];
    root=i; /* in case I might decide to actually compute the permutation */
    }

printf("%ld\n",max);
}

