#include "basic.cpp"
#include <algorithm>
#include <queue>


struct state		// structure to store nodes in priority queue
{
    int id;
    double dist;
    int fuel;
    state()
     {
            id = S; dist=0; fuel=0;
     }
    bool operator<(const state &b) const
     {
            return dist > b.dist;				// reverse "<" operator for STL priority queue compatibility
     }
};


bool used[MAXN][MAXC];
double mindist[MAXN][MAXC];


double dijkstra()
{
    for (int i=1; i<=N ;i++)
     F(f,C+1)
      mindist[i][f] = 1e100;
    mindist[S][0] = 0;
    
    std::priority_queue<state> q;
    q.push( state() );
    state cur,next;
    
    while ( !q.empty() ) 
     {
	  cur = q.top();
	  q.pop();
	  if ( used[cur.id][cur.fuel] ) continue;
	  
	  used[cur.id][cur.fuel] = 1;

	  F(i,adj[cur.id].size())
	   {
            next.id = adj[cur.id][i];
            next.dist = cur.dist + dist[cur.id][next.id];
            next.fuel = cur.fuel + fuel[cur.id][next.id];
	    
		    if ( next.fuel <= C && next.dist < mindist[next.id][next.fuel] )
		     {
			     if ( a[next.id].refuel ) next.fuel = 0;
			     q.push(next);
			     mindist[next.id][next.fuel] = next.dist;
		     }
	   }
     }

    double ret = 1e100;
    F(i,C+1)
     if (ret > mindist[T][i])
      ret = mindist[T][i];
    return ret;
}

int main()
{
    readInput();

    printOutput(dijkstra());
}
