#include "basic.cpp"
#include <algorithm>
#include <cstring>
#include <queue>

struct state{
    int id;
    double dist;
	int fuel;
        bool operator<(const state &b) const
         {
                return fabs(dist - b.dist) < EPS ? fuel > b.fuel : dist > b.dist;	// reverse "<" operator for STL priority queue compatibility
            }
        state(){}
        state(int _id,double _dist,int _fuel){ id=_id, dist=_dist, fuel=_fuel; }
    };
    
    
double curdist[MAXN];
int curfuel[MAXN];


bool isok(const state &cur)
{
    if ( cur.fuel > C ) return 0;
    if ( curdist[cur.id] > 1e99 ) return 1;
    if ( fabs(cur.dist - curdist[cur.id]) < EPS ) return 0;
    return cur.fuel < curfuel[cur.id];
}

double pfs()
{
    for (int i=1;i<=N;i++)
     curdist[i] = 1e100;
     
    std::priority_queue<state> q;
    q.push( state(S,0,0) );
    state cur,next;

    while ( !q.empty() )
     {
        cur = q.top();
        q.pop();
        if ( !isok(cur) ) continue;
        if ( cur.fuel > C ) continue;
	    
	    if ( a[cur.id].refuel ) cur.fuel = 0;

        curdist[cur.id] = cur.dist;
        curfuel[cur.id] = cur.fuel;

	    if ( cur.id == T ) break;
	    
            F(i,adj[cur.id].size())
             {
                    next.id = adj[cur.id][i];
                    next.dist = cur.dist + dist[cur.id][next.id];
                    next.fuel = cur.fuel + fuel[cur.id][next.id];
                    if ( !isok(next) ) continue;
                    q.push(next);
             }
     }

   return curdist[T];
}


int main()
{
    readInput();

    printOutput(pfs());
    
    return 0;
}
