
#include <stdio.h>
#include <stdlib.h>


#define MAXN (100 * 1024)


int N, Q;

struct edge {
	int to;
	int cost;
	struct edge *next;
} edges[MAXN * 2];

struct edge * edgePts[MAXN];
int numEdges = 0;

void addEdge(int from, int to, int cost) {
	edges[numEdges].to = to;
	edges[numEdges].cost = cost;
	edges[numEdges].next = edgePts[from];
	edgePts[from] = edges + numEdges;
	numEdges ++;
}

void loadGraph(FILE * f) {

	int i, nm1;
	
	fscanf(f, "%d%d", &N, &Q);

	nm1 = N - 1;
	
	for (i = 0; i < nm1; i++) {
		int a,b,c;
		fscanf(f, "%d%d%d", &a, &b, &c);
		a--;
		b--;
		addEdge(a,b,c);
		addEdge(b,a,c);
	}
}


int fronta[MAXN + 10];
int fstart, fend;
int dist[MAXN];



int query(int from, int to) {

	int i;

	if (from == to) {
		return 0;
	}
	
	for (i = 0; i < N; i++) {
		dist[i] = -1;
	}

	dist[from] = 0;
	fronta[0] = from;
	fstart = 0; fend = 1;

	while (fend > fstart) {
		struct edge *cur;
		int v = fronta[fstart++];
		int d = dist[v];

		for (cur = edgePts[v]; cur; cur = cur->next) {
			int w = cur->to;
			if (dist[w] >= 0) {
				continue;
			}
			dist[w] = d + cur->cost;
			fronta[fend++] = w;
			if (w == to) {
				break;
			}
		}
	}

	return dist[to];
}



int main() {
	
	int i;

	FILE *in = fopen("railway.in","rt");
	FILE *out = fopen("railway.out","wt");

	if (!in || !out) {
		fprintf(stderr,"Something fishy\n");
		exit(1);   /* never returns */
	}


	loadGraph(in);

	for (i = 0; i < Q; i++) {
		int a,b;
		fscanf(in, "%d%d", &a,&b);
		a--; b--;
		fprintf(out, "%d\n", query(a,b));
	}
	
	return 0;
}

