/* This is a solution in linear time which I started to write during the contest,
 * but never had time to finish. It's essentially complete, but there is still
 * some bug skulking somewhere.   --Martin Mares <mj@ucw.cz>
 */

#include <stdio.h>
#include <stdlib.h>

#define MAXN 100000
#define MAXE (2*MAXN)

int edepth[MAXE+8];
int E;

static inline int min(int x, int y)
{
	return (edepth[x] < edepth[y]) ? x : y;
}

/*** RMQ O(n*log n) / O(1) ***/

#define MAXL MAXE
#define MAXLOG 17

int lint[MAXLOG][MAXL];
char llog[MAXL];
int LN;

void lprep(int *a, int n)
{
	LN = n;
	int l, i, j;
	for (i=0; i<LN; i++)
		lint[0][i] = a[i];
	for (l=1; l<MAXLOG; l++) {
		j = 0;
		while (j+(1 << l) <= LN) {
			lint[l][j] = min(lint[l-1][j], lint[l-1][j+(1 << (l-1))]);
			j++;
		}
	}
	l = 0;
	for (i=0; i<LN; i++) {
		if ((2 << l) < i)
			l++;
		llog[i] = l;
	}
}

int lmin(int x, int y)
{
	// printf(">> lmin(%d,%d)\n", x, y);
	int len = y-x;
	int level = llog[len];
	return min(lint[level][x], lint[level][y-(1 << level)]);
}

/*** RMQ O(n) / O(1) ***/

#define BLOCK 8
#define MAXBLOCKS (1 << BLOCK)
#define MAXM (MAXE/BLOCK+1)

int mblktype[MAXM];
int compressed[MAXM];
int M;
char inside[MAXBLOCKS][BLOCK][BLOCK];
char have_block[MAXBLOCKS];

void minitblk(int type, int pos)
{
	int i, j;
	have_block[type] = 1;
	for (i=0; i<BLOCK-1; i++) {
		int z = pos+i;
		for (j=i+1; j<=BLOCK; j++) {
			// printf("%02x: %d %d -> %d\n", type, i, j-i, z);
			inside[type][i][j-i] = z-pos;
			z = min(z, pos+j);
		}
	}
}

static inline int bmin(int bb, int x, int len)
{
	// printf(">> imin bb=%d b=%02x (%d+%d) = %d\n", bb, mblktype[bb], x, len, inside[mblktype[bb]][x][len] + BLOCK*bb);
	return inside[mblktype[bb]][x][len] + BLOCK*bb;
}

void mprep(void)
{
	while (E % BLOCK) {
		edepth[E] = edepth[E-1] + 1;
		E++;
	}
	M = E/BLOCK;
	int i, j = 0, k;
	for (i=0; i<M; i++) {
		int z = j++;
		int type = 0;
		for (k=1; k<BLOCK; k++) {
			type <<= 1;
			if (edepth[j] == edepth[j-1] + 1)
				type |= 1;
			else if (edepth[j] == edepth[j-1] - 1)
				;
			else {
				fprintf(stderr, "Touche!\n");
				exit(1);
			}
			z = min(k, j++);
		}
		compressed[i] = z;
		mblktype[i] = type;
		if (!have_block[type])
			minitblk(type, i*BLOCK);
	}
	lprep(compressed, M);
}

int mmin(int x, int y)
{
	if (x > y) {
		int t = x;
		x = y;
		y = t;
	}
	int bx = x / BLOCK;
	int by = (y-1) / BLOCK;
	if (bx == by) {
		return (bx*BLOCK) + bmin(bx, x % BLOCK, y-x);
	} else {
		int z = x;
		if (x % BLOCK) {
			z = min(z, bmin(bx, x % BLOCK, BLOCK-(x%BLOCK)));
			bx++;
		}
		if (y % BLOCK) {
			z = min(z, bmin(by, 0, y % BLOCK));
			by--;
		}
		if (bx <= by)
			z = min(z, lmin(bx, by+1));
		return z;
	}
}

/*** Railway and reduction to LCA and RMQ ***/

FILE *fi, *fo;
int N, Q;
int edges[MAXN+1], dest[MAXE], price[MAXE], t1[MAXN], t2[MAXN], t3[MAXN];
int mark[MAXN], first[MAXN], epricesum[MAXE], evertex[MAXE];

void rd(void)
{
	int i;
	fscanf(fi, "%d%d", &N, &Q);
	for (i=0; i<N-1; i++) {
		fscanf(fi, "%d%d%d", t1+i, t2+i, t3+i);
		t1[i]--;
		t2[i]--;
		edges[t1[i]]++;
		edges[t2[i]]++;
	}
	for (i=1; i<=N; i++)
		edges[i] += edges[i-1];
	for (i=0; i<N-1; i++) {
		dest[--edges[t1[i]]] = t2[i];
		price[edges[t1[i]]] = t3[i];
		dest[--edges[t2[i]]] = t1[i];
		price[edges[t2[i]]] = t3[i];
	}
}

void dfs(int v, int d, int p)
{
	int i;
	first[v] = E;
	edepth[E] = d;
	epricesum[E] = p;
	evertex[E++] = v;
	for (i=edges[v]; i<edges[v+1]; i++) {
		int w = dest[i];
		if (!mark[w]) {
			mark[w] = 1;
			dfs(w, d+1, p+price[i]);
			edepth[E] = d;
			epricesum[E] = p;
			evertex[E++] = v;
		}
	}
}

void dump_tree(void)
{
	int i;
	for (i=0; i<2*N-1; i++) {
		printf("%5d: %5d %10d %5d\n", i, edepth[i], epricesum[i], evertex[i]);
	}
}

int main(void)
{
	int i;
#if 0
	/*          0  1  2  3  4  5  6  7  8  9 10 11 12 13 */
	int z[] = { 1, 2, 3, 2, 3, 4, 5, 4, 3, 4, 3, 2, 1 };
	E = sizeof(z)/sizeof(z[0]);
	for (i=0; i<E; i++)
		edepth[i] = z[i];
	mprep();
	printf("%d\n", mmin(1, 13));
	return 0;
#endif

	fi = fopen("railway.in", "r");
	fo = fopen("railway.out", "w");
	if (!fi || !fo)
		return 1;
	rd();
	mark[0] = 1;
	dfs(0, 0, 0);
	if (E != 2*N-1) { fprintf(stderr, "You liar!!! %d!!!\n", E); exit(1); }
	// dump_tree();
	mprep();
	for (i=0; i<Q; i++) {
		int x, y;
		fscanf(fi, "%d%d", &x, &y);
		x--;
		y--;
		int lca = mmin(first[x], first[y]);
		// printf("%d %d -> (%d,%d) -> lca %d -> vertex %d\n", x, y, first[x], first[y], lca, evertex[lca]);
		fprintf(fo, "%d\n", epricesum[first[x]] + epricesum[first[y]] - 2*epricesum[lca]);
	}
	return 0;
}
