
#include <stdio.h>
#include <stdlib.h>

#define MAXN (100 * 1024)

int N, Q;

struct edge {
	int to;
	int cost;
	struct edge *next;
} edges[MAXN * 2];

struct edge * edgePts[MAXN];
int numEdges = 0;

void addEdge(int from, int to, int cost) {
	edges[numEdges].to = to;
	edges[numEdges].cost = cost;
	edges[numEdges].next = edgePts[from];
	edgePts[from] = edges + numEdges;
	numEdges ++;
}

void loadGraph(FILE * f) {

	int i, nm1;
	
	fscanf(f, "%d%d", &N, &Q);

	nm1 = N - 1;
	
	for (i = 0; i < nm1; i++) {
		int a,b,c;
		fscanf(f, "%d%d%d", &a, &b, &c);
		a--;
		b--;
		addEdge(a,b,c);
		addEdge(b,a,c);
	}
}

int level[MAXN];
int parent[MAXN];
int lenToRoot[MAXN];

void dfs(int v, int xlen, int xlev, int xp) {
	struct edge *cur;

	if (level[v] >= 0) {
		return;
	}

	level[v] = xlev;
	lenToRoot[v] = xlen;
	parent[v] = xp;

	for (cur = edgePts[v]; cur; cur = cur->next) {
		dfs(cur->to, cur->cost + xlen, xlev + 1,v);
	}
}

void precalc() {
	int i;

	for (i = 0; i < N; i++) {
		level[i] = -1;
	}
	
	dfs(0,0,0,0);
}



int gcp(int from, int to) {
	
	int d;
	
	if (level[from] < level[to]) {
		int p = from; from = to; to = p;
	}

	d = level[from] - level[to];
	for (; d > 0; d --) {
		from = parent[from];
	}

	while (from != to) {
		from = parent[from];
		to = parent[to];
	}

	return from;
}



int query(int from, int to) {
	return lenToRoot[from] + lenToRoot[to] - 2* lenToRoot[gcp(from,to)];	
}


int main() {
	
	int i;

	FILE *in = fopen("railway.in","rt");
	FILE *out = fopen("railway.out","wt");

	if (!in || !out) {
		fprintf(stderr,"Something fishy\n");
		exit(1);   /* never returns */
	}


	loadGraph(in);
	precalc();

	for (i = 0; i < Q; i++) {
		int a,b;
		fscanf(in, "%d%d", &a,&b);
		a--; b--;
		fprintf(out, "%d\n", query(a,b));
	}
	
	return 0;
}

