#include <cstdio>
#include <cstdlib>
#include <string>
#include <algorithm>
#include <utility>
#include <set>

using namespace std;

#define REP(a,n) for (int a=0; a<(n); ++a)
#define FOR(a,l,h) for (int a=(l); a<=(h); ++a)

////////////////////////////

#define SIZE 1000001

int N;
int pola[SIZE][2];

int ran(int l, int h)
{
	return l+random()%(h-l+1);
}

void save(string tn)
{
	FILE *f = fopen(("exp"+tn+".in").c_str(), "w");
	fprintf(f, "%d\n", N);
	REP(a, N+1)
		fprintf(f, "%d %d\n", pola[a][0], pola[a][1]);
	fclose(f);
	printf("OK\n");
}

void start(string tn, int rs)
{
	printf("%s \t... ", tn.c_str());
	fflush(stdout);
	srandom(rs);
}

void generate(string tn, int rs, int NN, bool small, bool special = false)
{
	start(tn, rs); N = NN;
	static int wybor[2][SIZE];
	set<int> sel[2];
	REP(a, N+1)
		REP(b, 2)
		{
			wybor[b][a] = small ? a : ran(0, 2000000000);
			if (sel[b].find(wybor[b][a])!=sel[b].end())
				--b;
			else
				sel[b].insert(wybor[b][a]);
		}
	if (special)
	{
		sort(wybor[0], wybor[0]+N+1);
		sort(wybor[1], wybor[1]+N+1);
		REP(b, 2)
			pola[0][b] = wybor[b][0];
		FOR(a, 1, N)
			{
				pola[a][0] = wybor[0][a];
				pola[a][1] = wybor[1][N+1-a];
			}
	}
	REP(a, N+1)
	{
		REP(b, 2)
		{
			int zos = N+1-a;
			int c = ran(0, zos-1);
			pola[a][b] = wybor[b][c];
			wybor[b][c] = wybor[b][zos-1];
		}
	}
	save(tn);
}

int main(int argc, char **argv)
{
	/*       test     r_seed         N  small special */
	generate("1" 	, 1313244,      10,  true);
	generate("2" 	, 2315424,     100, false);
	generate("3"    , 3218819,    1000,  true);
	generate("4" 	, 4313244,   10000, false);
	generate("5" 	, 5314444,  100000,  true);
	generate("6"	, 6991459, 1000000, false);
	generate("7" 	, 7314312, 1000000,  true);
	generate("8" 	, 8344124, 1000000, false, true);
	generate("9"	, 9442352, 1000000,  true);
	generate("10" 	, 1132351, 1000000, false);
}


