#include <cstdio>
#include <cctype>
#include <cstdlib>
#include <cstring>
#include <set>
#include <algorithm>

#define REP(a,n) for (int a=0; a<(n); ++a)
#define FOR(a,l,h) for (int a=(l); a<=(h); ++a)

using namespace std;

#define INF 1000000000

char buf[1024];
int line = 0;
bool no_newline = false;

void error(char *str)
{
	printf("WRONG (line %d): %s\n", line, str);
	exit(1);
}

void read_ints(int n, int last=0)
{
	++line;
	fgets(buf, sizeof(buf), stdin);
	int l = strlen(buf);
	if (!l || no_newline)
		error("Unexpected end of file");
	if (buf[l-1]!='\n')
		no_newline = true;
	else
		--l;
	buf[l] = 0;
	int dl = 0;
	REP(a, l)
	{
		if (!isdigit(buf[a]) && buf[a]!=' ')
			error("Illegal character");
		if (isdigit(buf[a]))
		{
			if (!dl)
				--n;
			++dl;
			if (dl>9 && (dl>10 || buf[a-9]!='1'))
				error("Integer too big");
		}
		else
		{
			if (!n)
				error("Unexpected characters at end of line");
			if (!a || buf[a-1]==' ')
				error("Too many spaces");
			dl = 0;
		}
	}
	if (n)
		error("Unexpected end of line");
}

void end_of_file()
{
	if (no_newline)
		error("No trailing endline");
	if (fgets(buf, sizeof(buf), stdin)!=NULL)
	{
		++line;
		error("Unexpected characters at end of file\n");
	}
}

int main()
{
	int N;
	read_ints(1);
	sscanf(buf, "%d", &N);
	if (1>N || N>1000000)
		error("N out of range");
	set<int> tab[2];
	REP(a,N+1) 
	{
		int x,y;
		read_ints(2);
		sscanf(buf, "%d%d", &x, &y);
		if (0>x || x>2000000000)
			error("x out of range");
		if (0>y || y>2000000000)
			error("y out of range");
		if (tab[0].find(x)!=tab[0].end())
			error("The same x twice");
		if (tab[1].find(y)!=tab[1].end())
			error("The same y twice");
		tab[0].insert(x);
		tab[1].insert(y);
	}
	end_of_file();
	printf("OK\n");
}
