#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

static void __attribute__((noreturn)) bad(char *msg, ...)
{
  va_list args;
  va_start(args, msg);
  printf("WRONG ");
  vprintf(msg, args);
  printf("\n");
  va_end(args);
  exit(1);
}

#define MAXN 400
#define MAXK 400
int N, K;
int n[MAXN], a[MAXN], last[MAXN];
int sets[MAXK][MAXN+1];

static void readin(FILE *f)
{
	int i;
  fscanf(f, "%d%d", &N, &K);
  if (N > MAXN || K > MAXK)
    bad("Input limits");
  for (i=0; i<N; i++)
    fscanf(f, "%d", &n[i]);
  for (i=0; i<K; i++)
    {
      int j = 0, d;
      while ((fscanf(f, "%d", &d) == 1) && d >= 0)
	{
	  if (d < 1 || d > N)
	    bad("Input");
	  if (j >= MAXN)
	    bad("Input set size");
	  d--;
	  sets[i][j++] = d;
	  if (last[d] == i+1)
	    bad("Input dup");
	  last[d] = i+1;
	}
      sets[i][j] = -1;
    }
}

static int getnum(FILE *f)
{
  for(;;)
    {
      int c = fgetc(f);
      if (c < 0)
	return -3;
      if (c == '\r')
	continue;
      if (c == '\n')
	return -2;
      if (c != ' ' && c != '\t')
	{
	  ungetc(c, f);
	  break;
	}
    }
  int n;
  if (fscanf(f, "%d", &n) != 1)
    bad("Malformed number");
  if (n >= -1)
    return n;
  bad("Unexpected negative number");
}

static void check(FILE *f)
{
  int c = fgetc(f);
  int i;

  if (c < 0)
    bad("Empty output");
  if (c == 'I')
    {
      if (N == 251 && K == 250 || N == 2 && K == 1)
	return;
      bad("Claims no solution, but there is one");
    }
  ungetc(c, f);

  for (i=0; i<N; i++)
    a[i] = n[i];
  for (i=0; i<K; i++)
    {
		int j;
      int x = getnum(f);
      if (x < 0)
	bad("Missing number #%d", i);
      if (x > 1000000)
	bad("Number #%d too large", i);
      for (j=0; sets[i][j] >= 0; j++)
	a[sets[i][j]] = (a[sets[i][j]] + x) % 7;
    }
  for (i=0; i<N; i++)
    if (a[i] % 7 != 6)
      bad("Citizen #%d is only %d-happy", i, a[i]);
}

int main(int argc, char **argv)
{
  char *in = argv[1];
  char *out = argv[2];

  FILE *f = fopen(in, "r");
  if (!f)
    bad("Cannot open input file");
  readin(f);
  fclose(f);

  f = fopen(out, "r");
  if (!f)
    bad("Cannot open output file");
  check(f);
  fclose(f);

  puts("OK");
  return 0;
}
