#include <list>
#include <queue>
#include <set>
#include <svio.h>

using namespace std;

#define REP(i,n) for (int i=0;i<n;++i)
#define FOREACH(it,x) for (__typeof((x).begin()) it=((x).begin()); it!=(x).end();++it)
#define FOR(i,p,k) for (int i=p; i<=k;++i)
#define ALL(x) x.begin(),x.end()
#define NUM(x) x.to_ulong()


const int max_town=100000;
const int inf=1000000000;

list<pair<int,int> > G[max_town];
list<int> pop[max_town];

struct elem {
	int d, v;
	elem (int a, int b): v(a),d(b){}
};

bool operator < (elem a, elem b){
	return a.d>b.d;
}
	
int m,n;
	
int d[max_town];

void dijkstra(int v){
	priority_queue<elem> q;
	FOR(i,1,n) d[i]=inf;
	d[v]=0;
	q.push(elem(v,d[v]));
	while (!q.empty()){
		int u=q.top().v;
		if (q.top().d > d[u]){ q.pop(); continue;}
		q.pop();
		FOREACH(it,G[u])
			if (d[it->first]>d[u]+it->second){
				pop[it->first].clear();
				pop[it->first].push_back(u);
				d[it->first]=d[u]+it->second;
				q.push(elem(it->first,d[it->first]));
			} else if (d[it->first]==d[u]+it->second)
				pop[it->first].push_back(u);
	}
}
bool on_path[max_town]={0};

void dfs1(int v){
	on_path[v]=true;
	FOREACH(it,pop[v])
		if (!on_path[*it]) dfs1(*it);
}
bool od[max_town]={0};
int preorder[max_town]={0};
int back[max_town]={0};
int t=0;
set<int> articulation;
void dfs2(int v){
	od[v]=true;
	preorder[v]=back[v]=(++t);
	FOREACH(it,G[v]){
		int w=it->first;
		if (on_path[w] && abs(d[w]-d[v])==it->second && !od[w]){
			dfs2(w);
			back[v]<?=back[w];
			if (back[w]>=preorder[v]) articulation.insert(v);
		} else if (on_path[w] && abs(d[w]-d[v])==it->second) back[v]<?=preorder[w];
	}
}

int main(){
	n = read_int();
	m = read_int();
	for (int i=0;i<m;++i){
		int x,y,z;
		x = read_int();
		y = read_int();
		z = read_int();
		G[x].push_back(make_pair(y,z));
		G[y].push_back(make_pair(x,z));
	}
	dijkstra(1);
	if (pop[n].empty()) fprintf(stderr,"no route from 1 to n\n");
	dfs1(n);
	dfs2(1);
	articulation.insert(1);
	articulation.insert(n);
	write_int(n- articulation.size());
	return 0;
}
