#include <iostream>
#include <list>
#include <queue>
#include <set>

using namespace std;

#define REP(i,n) for (int i=0;i<n;++i)
#define FOREACH(it,x) for (__typeof((x).begin()) it=((x).begin()); it!=(x).end();++it)
#define FOR(i,p,k) for (int i=p; i<=k;++i)
#define ALL(x) x.begin(),x.end()
#define NUM(x) x.to_ulong()


const int max_town=100000;
const int inf=1000000000;

list<pair<int,int> > G[max_town];
list<int> pop[max_town];

struct elem {
	int d, v;
	elem (int a, int b): v(a),d(b){}
};

bool operator < (elem a, elem b){
	return a.d>b.d;
}
	
int m,n;
	
int d[max_town];

void dijkstra(int v){
	priority_queue<elem> q;
	FOR(i,1,n) d[i]=inf;
	d[v]=0;
	q.push(elem(v,d[v]));
	while (!q.empty()){
		int u=q.top().v;
		if (q.top().d > d[u]){ q.pop(); continue;}
		q.pop();
		FOREACH(it,G[u])
			if (d[it->first]>d[u]+it->second){
				pop[it->first].clear();
				pop[it->first].push_back(u);
				d[it->first]=d[u]+it->second;
				q.push(elem(it->first,d[it->first]));
			} 
	}
}
bool on_path[max_town]={0};



int main(){
	cin >> n >> m;
	for (int i=0;i<m;++i){
		int x,y,z;
		cin >> x >> y >> z;
		G[x].push_back(make_pair(y,z));
		G[y].push_back(make_pair(x,z));
	}
	dijkstra(1);
	int ile=1;
	for (int v=n;!pop[v].empty();v=pop[v].front()) ++ile;

	cout << n- ile << endl;
	return 0;
}
