#include <stdlib.h>

#if 0
#include <stdio.h>
static inline int gc(void) { return getchar(); }
static inline void write_char(int c) { putchar(c); }
#else
#include <svio.h>
static int gclen = -1, gcpos = -1;
static int gc(void)
{
 restart:
  if (gcpos < gclen)
    {
      gcpos++;
      return read_char();
    }
  else if (gclen >= 0)
    {
      gcpos = gclen = -1;
      return '\n';
    }
  else
    {
      gcpos = 0;
      gclen = read_strlen();
      goto restart;
    }
}
#endif

#define MAX 10000000		/* input length */
#define MAXI (MAX/5+1)		/* internal nodes */

struct {
  unsigned flags:8;
  unsigned len:24;
} q[MAXI+1];
int t[4], neg;

static void xf(void)
{
  int i = 0;
  int j = 0;
  int from = -1;
  write_char('(');
  for (;;)
    {
      int z[4], k=i+1, l;
      for (l=0; l<4; l++)
	{
	  if (q[i].flags & (0x10 << l))
	    z[l] = -1 - ((q[i].flags >> l) & 1);
	  else
	    {
	      z[l] = k;
	      k += q[k].len;
	    }
	  // printf("\t%d -> %d\n", l, z[l]);
	}
      if (from >= 0)
	{
	  for (j=0; j<4 && z[t[j]] != from; j++)
	    ;
	  if (j >= 4)
	    exit(42);
	  from = -1;
	  j++;
	}
      if (j < 4)
	{
	  k = z[t[j++]];
	  if (k < 0)
	    write_char('a' + ((-1-k) ^ neg));
	  else
	    {
	      q[k].len = i;
	      i = k;
	      j = 0;
	      write_char('(');
	    }
	}
      else
	{
	  int oi = q[i].len;
	  write_char(')');
	  if (!i)
	    return;
	  q[i].len = k-i;
	  from = i;
	  i = oi;
	}
    }
}

int main(void)
{
  int N, c, i, j, sp;

  q[MAXI].flags = 0;
  for (N=0, j=0, sp=MAXI; (c = gc()) != '\n'; )
    switch (c)
      {
      case 'a':
	q[sp].flags |= (0x10 << j++);
	break;
      case 'b':
	q[sp].flags |= (0x11 << j++);
	break;
      case '(':
	q[sp].flags |= (0x01 << j);
	q[N].len = sp;
	q[N].flags = 0;
	sp = N++;
	j = 0;
	break;
      case ')':
	i = sp;
	sp = q[i].len;
	q[i].len = N - i;
	for (j=0; (q[sp].flags & (0x11 << j)) ; j++)
	  ;
	break;
      default:
	return 101;
      }

  t[0] = 0; t[1] = 1; t[2] = 2; t[3] = 3;
  neg = 0;
  while ((c = gc()) != '\n')
    switch (c)
      {
      case 'L':
	j = t[0]; t[0] = t[1]; t[1] = t[3]; t[3] = t[2]; t[2] = j;
	break;
      case 'R':
	j = t[0]; t[0] = t[2]; t[2] = t[3]; t[3] = t[1]; t[1] = j;
	break;
      case 'X':
	j = t[0]; t[0] = t[1]; t[1] = j;
	j = t[2]; t[2] = t[3]; t[3] = j;
	break;
      case 'Y':
	j = t[0]; t[0] = t[2]; t[2] = j;
	j = t[1]; t[1] = t[3]; t[3] = j;
	break;
      case 'N':
	neg = !neg;
	break;
      default:
	return 112;
      }

  //for (i=0; i<N; i++)
  //printf("%d: %02x %d\n", i, q[i].flags, q[i].len);

  if (N)
    xf();
  else if (q[MAXI].flags & 0x10)
    write_char('a' + ((q[MAXI].flags & 0x01) ^ neg));
  write_char('\n');
  return 0;
}
