//buggy model solution - assumes there's only one pipe between a pair of nodes 

#include<cstdio>
#include<algorithm>
#include<vector>
#include<cmath>

using namespace std;

#define MAX_N 100

//useful floating-point macros
#define EPS 	0.000000000001
#define ISZERO(x)  (fabs(x) <= EPS)

void swap_rows(long double (*equations) [MAX_N+1], int n, int a, int b)
{
    for(int i=0; i<n+1; i++)
	swap(equations[a][i], equations[b][i]);
}


void multiply_row(long double (*equations) [MAX_N+1], int n, int a, long double x)
{
    for(int i=0; i<n+1; i++)
	equations[a][i] *= x;
}

void subtract_row(long double (*equations) [MAX_N+1], int n, int a, int b, long double x)
{
    for(int i=0; i<n+1; i++)
	equations[a][i] -= equations[b][i]*x;
}


//Gaussian elimination - hope it's accurate enough

void solve_system(long double (*equations) [MAX_N+1], int n)
{
/*        for(int i=0; i<n; i++)
    {
	for(int j=0; j<=n; j++)
	    printf("%.02Lf ", equations[i][j]);
	printf("\n");
    }
    printf("\n\n");
    return;*/
    int row, column;
    row = 0;
    column = 0;
    while(row < n && column < n)
    {
	if(ISZERO(equations[row][column]))
	{
	    for(int j=row+1; j<n; j++)
	    {
		if(!ISZERO(equations[j][column]))
		{
		    swap_rows(equations, n, row, j);
		    break;
		}
	    }
	}
	if(ISZERO(equations[row][column]))
	{
	    column ++;
	    continue;
	}
	multiply_row(equations, n, row, 1.0/equations[row][column]);
	for(int j=0; j<n; j++)
	{
	    if(row == j) continue;
	    if(!ISZERO(equations[j][column]))
	    {
//		printf("sub %d %d  %Lf\n", j, i, equations[j][i]);
		subtract_row(equations, n, j, row, equations[j][column]);
	    }
	}
	row++;
	column++;
    }
    for(int i=0; i<n; i++)
    {
	if(ISZERO(equations[i][i]))
	{
//	    printf("pow %d\n", i);
	    equations[n-1][i] = 1;
	    equations[n-1][n] = 1;
	    solve_system(equations, n);
	    break;
	}
    }
/*    for(int i=0; i<n; i++)
    {
	for(int j=0; j<=n; j++)
	    printf("%02.2Lf ", equations[i][j]);
	printf("\n");
    }
    printf("\n");*/
}

void check(long double (*equations) [MAX_N+1], long double (*solved) [MAX_N+1], int n)
{
    long double sum;
    for(int i=0; i<n; i++)
    {
	sum = 0;
	for(int j=0; j<n; j++)
	{
//	    if(!isnan(equations[i][j]*solved[j][n]))
	    //printf("biore %Lf %Lf\n", equations[i][j], solved[j][n]);
	    sum += equations[i][j]*solved[j][n];
	}
//	printf("%d %.20Lf\n", i, sum);
    }
}

void compute_flow(int (*max_flow)[MAX_N], int (*pipes)[MAX_N], int n)
{
    long double equations[MAX_N+1][MAX_N+1];
    long double copy[MAX_N+1][MAX_N+1];
    for(int i=1; i<n; i++) //conservation law for vertex i+1
    {
	for(int j=0; j<=n; j++) //the last column is reserved for result
	    equations[i-1][j] = 0;
	if(i == n-1)
	    equations[i-1][i] = 1;
	else
	for(int j=0; j<n; j++)
	{
	    if(i == j)
		continue;
	    //there exists a pipe between j and i
	    if(max_flow[j][i] != -1)
	    {
		equations[i-1][i] ++;
		equations[i-1][j] --;
	    }
	}
    }
    for(int i=0; i<=n; i++)
	equations[n-1][i] = 0;
    long double max_scale=-100;
    for(int i=0; i<=n; i++)
    for(int j=0; j<=n; j++)
	copy[i][j] = equations[i][j];
    solve_system(equations, n);
    check(copy, equations, n);
    for(int i=0; i<n; i++)
    for(int j=0; j<n; j++)
    {
	if(max_flow[i][j] == -1) continue;
//	printf("miedzy %d a %d plynie %Lf %d\n", i+1, j+1, (equations[i][n]- equations[j][n]), max_flow[i][j]);
	if(!ISZERO(equations[i][n]-equations[j][n]) && (max_scale < 0 || 
	     ((long double)(max_flow[i][j]))/fabs(equations[i][n]-equations[j][n]) < max_scale))
	{
	    
	    max_scale = ((long double)(max_flow[i][j]))/fabs(equations[i][n]-equations[j][n]);
//	    printf("zm %Lf\n", max_scale);
	}
    }
    long double res;
    res = 0;
    for(int i=1; i<n; i++)
    {
	if(max_flow[0][i] != -1)
	    res += (equations[0][n] - equations[i][n]);
    }
    printf("%.6Lf\n", res*max_scale);
}

void read_input(int (*max_flow)[MAX_N], int (*pipes)[MAX_N], int n, int m)
{
    int a, b, c;
    for(int i=0; i<n; i++)
    for(int j=0; j<n; j++)
	max_flow[i][j] = -1;
    for(int i=0; i<m; i++)
    {
	scanf("%d%d%d", &a, &b, &c); 
	a --; b --;
	
	    max_flow[a][b] = max_flow[b][a] = c;
    }
}

int main()
{
    int n, m;
    scanf("%d%d", &n, &m);
    int max_flow[MAX_N][MAX_N], pipes[MAX_N][MAX_N];
    
    read_input(max_flow, pipes, n, m);
    compute_flow(max_flow, pipes, n);
    return 0;
}
