//simply computes the max flow

#include<cstdio>
#include<algorithm>
#include<vector>
#include<queue>

using namespace std;

#define FOREACH(a,b) for(__typeof((b).begin()) a=(b).begin(); (a)!=(b).end(); ++(a))

struct node
{
    int max_flow, cur_flow, dest;
    node* next;
};

struct vertex
{
    node* head;
};

void add(vertex* v, int dest, int flow)
{
    node* ptr;
    for(ptr=v->head; ptr; ptr=ptr->next)
    {
	if(ptr->dest == dest)
	{
	    ptr->max_flow += flow;
	    return;
	}
    }
    node* newn;
    newn = new node;
    newn->max_flow = flow;
    newn->cur_flow = 0;
    newn->dest = dest;
    newn->next = v->head;
    v ->head = newn;
}

void read(int n, int m, vertex* graph)
{
    int a, b, c;
    for(int i=0; i<n; i++)
	graph[i].head = NULL;
    for(int i=0; i<m; i++)
    {
	scanf("%d%d%d", &a, &b, &c);
	a --; b --;
	add(&graph[a], b, c);
	add(&graph[b], a, c);
    }
}

void reverse_path(vertex* graph, int n, int* prev, int flow)
{
    int cur;
    node* ptr;
    cur = n-1;
    while(cur != 0)
    {
	//reverse prev[cur] -> cur
	for(ptr=graph[prev[cur]].head; ptr; ptr=ptr->next)
	{
	    if(ptr->dest == cur)
	    {
//		printf("%d %d -> %d %d\n", prev[cur], cur, flow, ptr->cur_flow);
		ptr->cur_flow += flow;
		break;
	    }
	}
	for(ptr=graph[cur].head; ptr; ptr=ptr->next)
	{
	    if(ptr->dest == prev[cur])
	    {
		ptr->cur_flow -= flow;
		break;
	    }
	}
	cur = prev[cur];
    }
}

int path(vertex* graph, int n, int* prev)
{
    int max_flow[100];
    queue<int> q;
    int cur;
    node* ptr;
    for(int i=0; i<n; i++)
	max_flow[i] = 0;
    max_flow[0] = 1000000;
    prev[0] = -2;
    q.push(0);
    while(!q.empty())
    {
	cur = q.front();
	q.pop();
	for(ptr=graph[cur].head; ptr; ptr=ptr->next)
	{
	    if(prev[ptr->dest] == -1 && (ptr->max_flow)-(ptr->cur_flow) > 0)
	    {
		prev[ptr->dest] = cur;
		max_flow[ptr->dest] = min(max_flow[cur], ptr->max_flow-ptr->cur_flow);
//		printf("from %d to %d %d  %d\n", cur, ptr->dest, max_flow[ptr->dest], max_flow[n-1]);
		q.push(ptr->dest);
	    }
	}
    }
//    printf("%d\n", max_flow[n-1]);
    return max_flow[n-1];
}

int max_flow(vertex* graph, int n)
{
    int ret, cur, prev[100];
    ret = 0;
    while(1)
    {
	for(int i=0; i<n; i++)
	    prev[i] = -1;
	cur = path(graph, n, prev);
	if(cur == 0) break;
	ret += cur;
	reverse_path(graph, n, prev, cur);
    }
    return ret;
}

int main()
{
    int n, m;
    vertex graph[100];
    scanf("%d%d", &n, &m);
    read(n, m, graph);
    printf("%d\n", max_flow(graph, n));
    return 0;
}
