#include <queue>
#include <string>
#include <cstdio>
#include <vector>
#include <iostream>

using namespace std;


struct node {
  int fear;
  int back;
  int next[26];
  node() {
    fear=0; 
    memset(next,-1,sizeof(next));
  }
};

vector<node> nodes;

void pridaj(string &s, int d)
{
  int n=0;
  for (int i=0;i<s.size();i++) {
    if (nodes[n].next[s[i]-'a']==-1) {
      nodes.push_back(node());
      nodes[n].next[s[i]-'a']=nodes.size()-1;
    }
    n=nodes[n].next[s[i]-'a'];
  }
  nodes[n].fear+=d;
}

void zbuduj()
{
  nodes.push_back(node()); 
  for (int i=0;i<26;i++) {
    nodes.back().next[i]=0;
  }
  nodes[0].back=nodes.size()-1;
  queue<int> q;
  q.push(0);
  while (!q.empty()) {
    int n=q.front();
    q.pop();
    for (int i=0;i<26;i++) {
      if (nodes[n].next[i]==-1) {
        nodes[n].next[i]=nodes[nodes[n].back].next[i];
      } else {
        nodes[nodes[n].next[i]].back=nodes[nodes[n].back].next[i];
        nodes[nodes[n].next[i]].fear+=nodes[nodes[nodes[n].back].next[i]].fear;
        q.push(nodes[n].next[i]);
      }
    }
  }
}

int memo[101][100*100+1];

int go(int left, int n)
{
  if (left==0) {
    return 0;
  }
  int &ret=memo[left][n];
  if (ret!=-1) return ret;

  ret=0;
  for (int i=0;i<26;i++) {
    ret>?=nodes[nodes[n].next[i]].fear+go(left-1,nodes[n].next[i]);
  }
  return ret;
}

int main()
{
  int n,k;
  memset(memo,-1,sizeof(memo));
  scanf("%d %d",&n,&k);
  nodes.push_back(node());

  for (int i=0;i<k;i++) {
    string slovo;
    int d;
    cin >> slovo >> d;
    pridaj(slovo,d);

  }
  zbuduj();
  printf("%d\n",go(n,0));
  int node=0;
  while (n) {
    int hod=go(n,node);
    for (int i=0;i<26;i++) {
      if (hod==nodes[nodes[node].next[i]].fear+go(n-1,nodes[node].next[i])) {
        printf("%c",i+'a');
        n--;
        node=nodes[node].next[i];
        break;
      }
    }
  }
  printf("\n");
  return 0;
}
