#include <queue>
#include <string>
#include <cstdio>
#include <vector>
#include <iostream>

using namespace std;


struct node {
  int fear;
  int back;
  int next[26];
  node() {
    fear=0; 
    memset(next,-1,sizeof(next));
  }
};

vector<node> nodes;

void pridaj(string s, int d)
{
  int n=0;
  for (int i=0;i<s.size();i++) {
    if (nodes[n].next[s[i]-'a']==-1) {
      nodes.push_back(node());
      nodes[n].next[s[i]-'a']=nodes.size()-1;
    }
    n=nodes[n].next[s[i]-'a'];
  }
  nodes[n].fear+=d;
}

void zbuduj()
{
  nodes.push_back(node()); 
  for (int i=0;i<26;i++) {
    nodes.back().next[i]=0;
  }
  nodes[0].back=nodes.size()-1;
  queue<int> q;
  q.push(0);
  while (!q.empty()) {
    int n=q.front();
    q.pop();
    for (int i=0;i<26;i++) {
      if (nodes[n].next[i]==-1) {
        nodes[n].next[i]=nodes[nodes[n].back].next[i];
      } else {
        nodes[nodes[n].next[i]].back=nodes[nodes[n].back].next[i];
        nodes[nodes[n].next[i]].fear+=nodes[nodes[nodes[n].back].next[i]].fear;
        q.push(nodes[n].next[i]);
      }
    }
  }
}

char slovo[1000];

int main(int argc, char *argv[])
{
  int n,k;
  if (argc<4) {
    return 1;
  }
  FILE *fin=fopen(argv[1],"r"); // vstup
  FILE *fout=fopen(argv[2],"r"); // jeho vystup
  FILE *fok=fopen(argv[3],"r"); // nas vystup
  int ores,res;
  fscanf(fout,"%d ",&ores);
  fscanf(fok,"%d",&res);
  if (ores!=res) {
    printf("WRONG The scariness is wrong\n");
    return 1;
  }

  fscanf(fin,"%d %d",&n,&k);
  nodes.push_back(node());

  for (int i=0;i<k;i++) {
    int d;
    fscanf(fin,"%s %d",slovo,&d);
    pridaj(slovo,d);
  }
  zbuduj();
  int v=0;
  int f=0;
  fgets(slovo,sizeof(slovo),fout);
  if (strlen(slovo)-1!=n) {
    printf("WRONG Wrong length of string\n");
    return 1;
  }
  for (int i=0;i<n;i++) {
    char ch=slovo[i];
    if (!islower(ch)) {
      printf("WRONG Got not lowercase letter\n");
      return 1;
    }
    f+=nodes[nodes[v].next[ch-'a']].fear;
    v=nodes[v].next[ch-'a'];
  }
  if (f!=res) {
    printf("WRONG The word does not have declared scariness.\n");
    return 1;
  }
  printf("OK\n");
  fclose(fin);
  fclose(fout);
  fclose(fok);
  return 0;
}
