#include <stdio.h>
#include <stdlib.h>

#define MAX 1000
#define INFTY 1000000000
#define CM 10
int N;
int h[MAX+1], w[MAX+1];
int W;

int B[MAX+1];

static inline int min(int x, int y)
{
  return (x < y) ? x : y;
}

static inline int max(int x, int y)
{
  return (x > y) ? x : y;
}

struct cache { int lastj, M; } cache[1010][MAX+2];

static int minw(int H, int i0, int j)
{
  struct cache *C = cache[H];
  C[j+1].lastj = j;
  C[j+1].M = 0;
  int start = i0;
  while (C[start+1].lastj != j)
    start++;
  for (int i=start; i>=i0; i--)
    {
      int mi = INFTY;
      if (h[i] <= H)
	mi = w[i] + C[i+1].M;
      //printf("\t\t\tinitial=%d\n", mi);
      int height = 0;
      int wmax = 0;
      for (int k=i; k<=j; k++)
	{
	  height += w[k];
	  if (height > H)
	    break;
	  wmax = max(wmax, h[k]);
	  //if (C[k+1].lastj != j) { fprintf(stderr, "ARGH!\n"); exit(1); }
	  mi= min(mi, wmax + C[k+1].M);
	  //printf("\t\t\tk=%d height=%d wmax=%d -> %d\n", k, height, wmax, mi);
	}
      C[i].lastj = j;
      C[i].M = mi;
      //printf("\t\tW(%d,%d,%d) = %d\n", H, i, j, mi);
    }
  return C[i0].M;
}

static int minh(int i, int j)
{
#if 1
  /* Check if the last value is still the correct one */
  static int lasth = 1;
  if (minw(lasth, i, j) <= W && (lasth == 1 || minw(lasth-1, i, j) > W))
    return lasth;
  /* Otherwise, start step-up binary search */
  int l = 1;
  int r = 1;
  while (minw(r, i, j) > W)
    {
      if (r >= 1000)
	return INFTY;
      l = r+1;
      r = min(2*r, 1000);
    }
  while (l < r)
    {
      int m = (l+r)/2;
      if (minw(m, i, j) <= W)
	r = m;
      else
	l = m+1;
    }
  lasth = l;
  return l;
#elif 1
  /* Simple linear approaching from the previous value */
  static int lasth = 1;
  if (minw(lasth, i, j) <= W)
    {
      while (lasth > 1 && minw(lasth-1, i, j) <= W)
	lasth--;
      return lasth;
    }
  for (;;)
    {
      if (lasth >= 1000)
	return INFTY;
      lasth++;
      if (minw(lasth, i, j) <= W)
	return lasth;
    }
#else
  /* Brute force */
  for (int h=1; h<=1000; h++)
    {
      if (minw(h, i, j) <= W)
	{
	  //printf("\th=%d w=%d\n", h, minw(h, i, j));
	return h;
	}
    }
  return INFTY;
#endif
}

int main(void)
{
  scanf("%d", &N);
  if (N > MAX) { fprintf(stderr, "ARGH(1)!\n"); exit(1); }
  for (int i=1; i<=N; i++)
    {
      scanf("%d%d", &h[i], &w[i]);
      if (h[i] < 1 || h[i] > 1000 || w[i] < 1 || w[i] > 1000) { fprintf(stderr, "ARGH(2)!\n"); exit(1); }
    }
  scanf("%d", &W);
  if (W < 1 || W > 10000) { fprintf(stderr, "ARGH(3)!\n"); exit(1); }

  B[0] = CM;
  for (int j=1; j<=N; j++)
    {
      B[j] = INFTY;
      for (int i=j; i>=1; i--)
	{
	  int mh = minh(i, j);
	  //printf("minh(%d,%d) = %d\n", i, j, mh);
	  if (mh >= INFTY)
	    break;
	  B[j] = min(B[j], mh + B[i-1] + CM);
	}
      //printf("\t-> B[%d] = %d\n", j, B[j]);
    }
  printf("%d\n", B[N]);

  return 0;
}
