#include <stdio.h>
#include <stdlib.h>

#define MAX 1000
#define INFTY 1000000000
#define CM 10
int N;
int h[MAX+1], w[MAX+1];
int W;

int B[MAX+1];
int M[MAX+2];

static inline int min(int x, int y)
{
  return (x < y) ? x : y;
}

static inline int max(int x, int y)
{
  return (x > y) ? x : y;
}

static int minw(int H, int i0, int j)
{
  M[j+1] = 0;
  for (int i=j; i>=i0; i--)
    {
      M[i] = INFTY;
      if (h[i] <= H)
	M[i] = w[i] + M[i+1];
      //printf("\t\t\tinitial=%d\n", M[i]);
      int height = 0;
      int wmax = 0;
      for (int k=i; k<=j; k++)
	{
	  height += w[k];
	  if (height > H)
	    break;
	  wmax = max(wmax, h[k]);
	  M[i] = min(M[i], wmax + M[k+1]);
	  //printf("\t\t\tk=%d height=%d wmax=%d -> %d\n", k, height, wmax, M[i]);
	}
      //printf("\t\tW(%d,%d,%d) = %d\n", H, i, j, M[i]);
    }
  return M[i0];
}

static int minh(int i, int j)
{
  for (int h=1; h<=1000; h++)
    {
      if (minw(h, i, j) <= W)
	{
	  //printf("\th=%d w=%d\n", h, minw(h, i, j));
	return h;
	}
    }
  return INFTY;
}

int main(void)
{
  scanf("%d", &N);
  if (N > MAX) { fprintf(stderr, "ARGH(1)!\n"); exit(1); }
  for (int i=1; i<=N; i++)
    {
      scanf("%d%d", &h[i], &w[i]);
      if (h[i] < 1 || h[i] > 1000 || w[i] < 1 || w[i] > 1000) { fprintf(stderr, "ARGH(2)!\n"); exit(1); }
    }
  scanf("%d", &W);
  if (W < 1 || W > 10000) { fprintf(stderr, "ARGH(3)!\n"); exit(1); }

  B[0] = CM;
  for (int j=1; j<=N; j++)
    {
      B[j] = INFTY;
      for (int i=j; i>=1; i--)
	{
	  int mh = minh(i, j);
	  //printf("minh(%d,%d) = %d\n", i, j, mh);
	  if (mh >= INFTY)
	    break;
	  B[j] = min(B[j], mh + B[i-1] + CM);
	}
      //printf("\t-> B[%d] = %d\n", j, B[j]);
    }
  printf("%d\n", B[N]);

  return 0;
}
