program xmas;

uses
	tree_lib;

type
	node_t = record
		selected: longint;
		parent: longint;
		enq: boolean;
	end;

	nodes_t = array[ 0..10000000 ] of node_t;
	nodes_p = ^nodes_t;
	queue_t = array[ 0..10000000 ] of longint;
	queue_p = ^queue_t;

var
	N: longint = 0;
	nodes: nodes_p = nil;
	lastDec: longint = 0;
	i: longint;
	move: longint = 0;
	queue: queue_p = nil;
	qhead: longint = 0;
	qtail: longint = 0;

procedure enq( what: longint );
var
	i: longint;
begin
	for i := 1 to neighbor_count( what ) do begin
		if ( nodes ^ )[ neighbor( what, i ) ].enq then
			continue;
		( nodes ^ )[ neighbor( what, i ) ].enq := true;
		( queue ^ )[ qtail ] := neighbor( what, i );
		inc( qtail );
	end;
end;

procedure decor( what: longint );
type
	av = record
		code: char;
		avail: boolean;
	end;
var
	avail: array[ 0..3 ] of av;
	i, j: longint;
	t, code: char;
begin
	avail[ 0 ].code := 'S';
	avail[ 1 ].code := 'B';
	avail[ 2 ].code := 'D';
	avail[ 3 ].code := 'A';
	for i := 0 to 3 do avail[ i ].avail := true;
	for i := 1 to neighbor_count( what ) do begin
		t := decoration( neighbor( what, i ) );
		for j := 0 to 3 do if t = avail[ j ].code then begin
			avail[ j ].avail := false;
			break;
		end;
	end;
	code := ' ';
	for i := 0 to 3 do if avail[ i ].avail then begin
		code := avail[ i ].code;
		break;
	end;
	decorate( what, code );
	( nodes ^ )[ what ].selected := move;
	enq( what );
end;

procedure doMove;
var
	deco: boolean = false;
begin
	inc( move );
	while lastDec > 1 do begin
		if decoration( lastDec ) <> ' ' then
			lastDec := ( nodes ^ )[ lastDec ].parent
		else if ( nodes ^ )[ lastDec ].selected = 0 then begin
			( nodes ^ )[ lastDec ].selected := move;
			enq( lastDec );
			lastDec := ( nodes ^ )[ lastDec ].parent;
		end else begin
			decor( lastDec );
			deco := true;
			break;
		end;
	end;
	if not deco then begin
		if qtail > 0 then begin
			while true do begin
				if decoration( ( queue ^ )[ qhead ] ) = ' ' then begin
					decor( ( queue ^ )[ qhead ] );
					break;
				end;
				inc( qhead );
			end;
		end else
			decor( 1 );
	end;
	lastDec := enemy;
	( nodes ^ )[ lastDec ].selected := move;
	enq( lastDec );
end;

procedure orientTree( src, where: longint );
var
	i: longint;
begin
	( nodes ^ )[ where ].parent := src;
	for i := 1 to neighbor_count( where ) do begin
		if( neighbor( where, i ) = src ) then
			continue;
		orientTree( where, neighbor( where, i ) );
	end;
end;

begin
	N := init;
	getmem( nodes, ( N + 1 ) * sizeof( node_t ) );
	getmem( queue, ( N + 1 ) * sizeof( longint ) );
	for i := 1 to N do begin
		( nodes ^ )[ i ].selected := 0;
		( nodes ^ )[ i ].parent := 0;
		( nodes ^ )[ i ].enq := false;
	end;
	orientTree( 0, 1 );
	while true do
		doMove;
end.
