
#include "tree_lib.h"

#include <stdlib.h>
#include <stdio.h>

#define CHECK( A )

static int N = 0;

typedef struct point_t {
	int neighbor_count, *neighbors;
	char decoration;
} point_t;
static point_t *points = NULL;
static int *buffer;

static void die( const char *msg ) {
	fprintf( stderr, "%s\n", msg );
	exit( 1 );
}

int init( void ) {
	CHECK( if( N ) die( "init already called" ); )
	FILE *f = fopen( "xmas.in", "rt" );
	CHECK( if( !f ) die( "Could not open input file" ); )
	fscanf( f, "%d", &N );
	points = (point_t *) malloc( N * sizeof *points );
	buffer = (int *) malloc( N * 2 * sizeof *buffer );
	for( int i = 0; i < N; ++ i ) {
		fscanf( f, "%d", &points[ i ].neighbor_count );
		points[ i ].neighbors = buffer;
		buffer += points[ i ].neighbor_count;
		for( int j = 0; j < points[ i ].neighbor_count; ++ j )
			fscanf( f, "%d", &points[ i ].neighbors[ j ] );
		points[ i ].decoration = ' ';
	}
	fclose( f );
	return( N );
}

int neighbor_count( int point ) {
	CHECK( if( !N ) die( "No init called" ); )
	point --;
	if( ( point < 0 ) || ( point >= N ) )
		return( 0 );
	return( points[ point ].neighbor_count );
}

int neighbor( int point, int index ) {
	CHECK( if( !N ) die( "No init called" ); )
	point --;
	index --;
	if( ( point < 0 ) || ( point >= N ) )
		return( 0 );
	if( ( index < 0 ) || ( index >= points[ point ].neighbor_count ) )
		return( 0 );
	return( points[ point ].neighbors[ index ] );
}

char decoration( int point ) {
	CHECK( if( !N ) die( "No init called" ); )
	point --;
	if( ( point < 0 ) || ( point >= N ) )
		return( ' ' );
	return( points[ point ].decoration );
}

int enemy( void ) {
	int point;
	char decoration;
	puts( "ENeMY!" );
	fflush( stdout );
	scanf( "%d", &point );
	if( !point )
		exit( 0 );
	while( ( decoration = getchar() ) == ' ' );
	while( getchar() != '\n' );
	points[ point - 1 ].decoration = decoration;
	return( point );
}

void decorate( int point, char decoration ) {
	int res;
	point --;
	printf( "FroMTreeLIB:%d '%c'\n", point + 1, decoration );
	fflush( stdout );
	scanf( "%d", &res );
	if( !res )
		exit( 0 );
	while( getchar() != '\n' );
	points[ point ].decoration = decoration;/* Will get killed if invalid */
}
