/* Model solution for the task Duopoly
 * Author: Jakub Radoszewski
 * Date: 05.06.2007
 */

#include<cstdio>
#include<cctype>
#include<cmath>
#include<cstdlib>
#include<algorithm>
#include<vector>
#include<string>
#include<list>
#include<deque>
#include<map>
#include<set>
#include<queue>
#include<stack>
#include<utility>
#include<sstream>
#include<cstring>
using namespace std;

#define FOR(I,A,B) for(int I=(A);I<=(B);I++)
#define FORD(I,A,B) for(int I=(A);I>=(B);I--)
#define REP(I,N) for(int I=0;I<(N);I++)
#define ALL(X) (X).begin(),(X).end()
#define PB push_back
#define MP make_pair
#define FI first
#define SE second
#define INFTY 100000000
#define VAR(V,init) __typeof(init) V=(init)
#define FOREACH(I,C) for(VAR(I,(C).begin());I!=(C).end();I++)

typedef vector<int> VI;
typedef pair<int,int> PII;
typedef long long ll;
typedef vector<string> VS;

ll nwd(ll a,ll b) { return !b?a:nwd(b,a%b); }
inline int CEIL(int a,int b) { return a%b ? a/b+1 : a/b; }
template <class T> inline T sqr(const T&a) { return a*a; }

/* Maxflow using Edmonds-Karp method */

#define MAX_N 1010

struct kraw
{
  int v1,v2,c;
  int n; /* this edge's neighbour */
  int wh; /* where am I on the neighbour list of v1 */
};

vector<kraw> t[MAX_N];
int n;

/* adds a directed edge */
void add_edge(int v1,int v2,int c)
{
  kraw e1,e2;
  e1.v1=v1; e1.v2=v2; e1.c=c; e1.n=t[v2].size(); e1.wh=t[v1].size();
  e2.v1=v2; e2.v2=v1; e2.c=0; e2.n=t[v1].size(); e2.wh=t[v2].size();
  t[v1].PB(e1); t[v2].PB(e2);
}

int d[MAX_N];
kraw par[MAX_N];
VI kol;

bool bfs(int pocz,int kon)
{
  REP(i,n) d[i]=INFTY;
  d[pocz]=0;
  kol.clear();
  kol.PB(pocz);
  REP(i,(int)kol.size())
  {
    int v=kol[i];
    if (v==kon) return true;
    int v2;
    FOREACH(it,t[v]) if ((*it).c>0 && d[v2=(*it).v2]==INFTY)
    {
      d[v2]=d[v]+1;
      par[v2]=*it;
      kol.PB(v2);
    }
  }
  return false;
}

int path(int pocz,int kon)
{
  int v=kon,w=INFTY;
  while (v!=pocz)
  {
    w=min(w,par[v].c);
    v=par[v].v1;
  }
  v=kon;
  while (v!=pocz)
  {
    kraw e=par[v];
    t[e.v1][e.wh].c-=w;
    t[e.v2][e.n].c+=w;
    v=par[v].v1;
  }
  return w;
}

int maxflow(int pocz,int kon)
{
  int wyn=0;
  while (bfs(pocz,kon))
    wyn+=path(pocz,kon);
  return wyn;
}

#define MAX_CH 1000000

int ch1[MAX_CH+1];
int ch2[MAX_CH+1];
int n1,n2,s,m;

bool czy[510][510];

int main()
{
  FOR(i,1,MAX_CH) ch1[i]=ch2[i]=-1;
  /* Byteland 1 */
  scanf("%d",&n1);
  REP(i,n1)
  {
    int p; scanf("%d",&p); s+=p;
    add_edge(0,i+2,p);
    scanf("%d",&m);
    while (m--)
    {
      int a;
      scanf("%d",&a);
      ch1[a]=i;
    }
  }
  /* Byteland 2 */
  scanf("%d",&n2);
  REP(i,n2)
  {
    int p; scanf("%d",&p); s+=p;
    add_edge(i+n1+2,1,p);
    scanf("%d",&m);
    while (m--)
    {
      int a;
      scanf("%d",&a);
      ch2[a]=i;
    }
  }
  FOR(i,1,MAX_CH) if (ch1[i]>=0 && ch2[i]>=0)
    czy[ch1[i]][ch2[i]]=1;
  REP(i,n1) REP(j,n2) if (czy[i][j])
    add_edge(i+2,j+2+n1,1000000);
  n=n1+n2+2;
  printf("%d\n",s-maxflow(0,1));
  return 0;
}
