/* Verifying program for the task Stock Exchange
 * Author: Jakub Radoszewski
 * Date: 07.06.2007
 * Complexity: O((n+m)log^2(n)) but improved
 */

#include<cstdio>
#include<cctype>
#include<cmath>
#include<cstdlib>
#include<algorithm>
#include<vector>
#include<string>
#include<list>
#include<deque>
#include<map>
#include<set>
#include<queue>
#include<stack>
#include<utility>
#include<sstream>
#include<cstring>
using namespace std;

#define FOR(I,A,B) for(int I=(A);I<=(B);I++)
#define FORD(I,A,B) for(int I=(A);I>=(B);I--)
#define REP(I,N) for(int I=0;I<(N);I++)
#define ALL(X) (X).begin(),(X).end()
#define PB push_back
#define MP make_pair
#define FI first
#define SE second
#define INFTY 100000000
#define VAR(V,init) __typeof(init) V=(init)
#define FOREACH(I,C) for(VAR(I,(C).begin());I!=(C).end();I++)

typedef vector<int> VI;
typedef pair<int,int> PII;
typedef long long ll;
typedef vector<string> VS;

ll nwd(ll a,ll b) { return !b?a:nwd(b,a%b); }
inline int CEIL(int a,int b) { return a%b ? a/b+1 : a/b; }
template <class T> inline T sqr(const T&a) { return a*a; }

#define MAX_N 100010

VI kiedy[270000];
int n,m,b,e,l,u,ile;
int p[MAX_N],x[MAX_N];

inline void insert(int krok,int co)
{
  int v=ile+co;
  kiedy[v].PB(krok);
  while (v!=1)
  {
    v/=2;
    kiedy[v].PB(krok);
  }
}

void preset(int v,int il)
{
  kiedy[v].reserve(il+1);
  if (v<=ile)
  {
    preset(2*v,il/2);
    preset(2*v+1,il/2);
  }
}

void buduj()
{
  ile=1;
  while (ile<n) ile*=2;
  preset(1,ile);
  FOR(i,1,2*ile+1) kiedy[i].PB(0);
  FOR(i,1,n) insert(i,p[i-1]);
}

inline int query(int v,int krok)
{
  return upper_bound(ALL(kiedy[v]),krok)-kiedy[v].begin()-1;
}

inline int zapyt(int krok,int co)
{
  if (co<0 || krok<=0) return 0;
  co=upper_bound(x,x+n+1,co)-x-1;
  if (co<0) return 0;
  int v=ile+co,wyn;
  wyn=query(v,krok);
  while (v!=1)
  {
    if (v%2) wyn+=query(v-1,krok);
    v/=2;
  }
  return wyn;
}

int main()
{
  scanf("%d%d",&n,&m);
  REP(i,n) scanf("%d",p+i);
  memcpy(x,p,sizeof(p));
  sort(x,x+n); x[n]=1000000001;
  REP(i,n) p[i]=lower_bound(x,x+n,p[i])-x;
  buduj();
  int pop=0;
  while (m--)
  {
    scanf("%d%d%d%d",&b,&e,&l,&u);
    l+=pop-1; u+=pop; b--;
    printf("%d\n",pop=zapyt(e,u)-zapyt(e,l)-zapyt(b,u)+zapyt(b,l));
  }
  return 0;
}
