/* Stock Exchange
 * Wrong solution based on model, but missing s_{i-1}
 * Tomasz Idziaszek
 * June 2007 */

#include <algorithm>
#include <cstdio>
using namespace std;

const int MAX = 100000;

struct node
{
   int price;	/* share price (BST-key)  */
   unsigned short rsize;
   		/* right subtree's size */
   short exist;	/* 1 if share is in tree; 0 if not */
   int left;	/* link to left subtree */
   int right;	/* link to right subtree */

   bool operator<(const node& b) const { return price < b.price; }
};

int price[MAX];
node nodes[17*MAX];
int nfree;		/* first free position in array nodes[] */
int roots[MAX+1];	/* roots of BSTs */
int n, m, l, u, j, k, last;

/* Creates links for BST nodes in subarray nodes[l..p]
 * and returns tree root. */
int build_tree(int l, int p) {
   const int s = (l + p) / 2;
   nodes[s].left = (l <= s-1) ? build_tree(l, s-1) : -1;
   nodes[s].right = (s+1 <= p) ? build_tree(s+1, p) : -1;
   return s;
}

/* Calculates number of nodes in tree of root _v_ and
 * updates its rsize. */
int update_size(int v) {
   int size = 0;
   if (nodes[v].right != -1) size = update_size(nodes[v].right);
   nodes[v].rsize = size;
   if (nodes[v].left != -1) size += update_size(nodes[v].left);
   return size + 1;
}

/* Creates tree's copy with erased share of price _price_.
 * Tree's root is _v_, function returns copy's root. */
int erase(int v, int price) {
   node no = nodes[v];
   if (price == nodes[v].price)
      no.exist = 0;
   else if (price < nodes[v].price)
      no.left = erase(nodes[v].left, price);
   else if (nodes[v].price < price) {
      no.right = erase(nodes[v].right, price);
      --no.rsize;
   }
   nodes[nfree] = no;
   return nfree++;
}

/* Returns number of shares with price greater than _price_,
 * which are in a tree of root _v_. */
int count(int v, int price) {
   if (v == -1) return 0;
   if (price == nodes[v].price) return nodes[v].rsize;
   if (nodes[v].price < price) return count(nodes[v].right, price);
   return count(nodes[v].left, price) + nodes[v].exist + nodes[v].rsize;
}


int main() {
   scanf("%d%d", &n, &m);
   for (int i = 0; i < n; ++i) {
      scanf("%d", &price[i]);
      nodes[i].price = price[i];
      nodes[i].exist = 1;
   }
   sort(nodes, nodes+n);
   nfree = n;
   roots[n] = build_tree(0, n-1);
   update_size(roots[n]);
   for (int i = n-1; i >= 0; --i)
      roots[i] = erase(roots[i+1], price[i]);

   last = 0;
   for (int i = 0; i < m; ++i) {
      scanf("%d%d%d%d", &j, &k, &l, &u);
      //l += last;
      //u += last;
      last = count(roots[k], l-1) - count(roots[j-1], l-1)
	 - count(roots[k], u) + count(roots[j-1], u);
      printf("%d\n", last);
   }
}

