// {{{ define
#include <stdio.h>
#include <cmath>
#include <stdlib.h>
#include <utility>
#include <algorithm>
#include <vector>
using namespace std;

#define FOR(q,n) for(int q=0;q<n;q++)
#define FOREACH(it,t) for(typeof(t.begin()) it=t.begin(); it!=t.end(); it++)
typedef long double ld;
typedef pair<ld,ld> tpoint;
// }}}

#define MAX 60000

#define fi first
#define se second
#define mp make_pair
#define pb push_back
tpoint body[2][MAX]; // body
int bodov[2];
int input[2][MAX][3];
int velocity[2][3];

tpoint lower_chain[2][MAX];
int lower_chain_size[2];
tpoint upper_chain[2][MAX];
int upper_chain_size[2];

// {{{ cross
ld cross_(tpoint a,tpoint b){
return a.fi*b.se-b.fi*a.se;
}
ld cross(tpoint a,tpoint b,tpoint c){
return (a.fi-b.fi)*(c.se-b.se)-
       (a.se-b.se)*(c.fi-b.fi);
}
// }}}

// {{{ init
void init(){
FOR(e,2) {
 scanf("%d",&bodov[e]);
 FOR(q,bodov[e])
   FOR(w,3) scanf("%d",&input[e][q][w]);
 FOR(w,3) scanf("%d",&velocity[e][w]); 
}
FOR(w,3) velocity[0][w]-=velocity[1][w];
}

ld sqr(ld x){
return x*x;
}
// }}}

// {{{ project
void project(){
pair<int,int> tmp[3];
FOR(w,3) tmp[w]=mp(abs(velocity[0][w]),w);
sort(tmp,tmp+3);
ld l2=sqr((ld)velocity[0][tmp[1].se]) +
           sqr((ld)velocity[0][tmp[2].se]);
ld l1=sqrt(l2);
           
FOR(e,2)
  FOR(q,bodov[e]) {
    body[e][q]=mp( 
      (
       (ld)input[e][q][tmp[2].se]*(ld)velocity[0][tmp[1].se] -
       (ld)input[e][q][tmp[1].se]*(ld)velocity[0][tmp[2].se] 
      ) / l1,
      ( (ld) input[e][q][tmp[1].se]*
        (ld) velocity[0][tmp[0].se]*
        (ld) velocity[0][tmp[1].se] +
        
        (ld) input[e][q][tmp[2].se]*
        (ld) velocity[0][tmp[0].se]*
        (ld) velocity[0][tmp[2].se]
      )/l2 - (ld) input[e][q][tmp[0].se]          

        );

#ifdef DEBUG
      body[e][q].fi+=4;
      body[e][q].se+=10;
      body[e][q].fi*=50;
      body[e][q].se*=50;
      ld t2=body[e][q].se;
      ld t1=body[e][q].fi;
      body[e][q].se=600-t1; //body[e][q].se;
      body[e][q].fi=t2; //body[e][q].fi;
#endif
  }

}
// }}}


// {{{ make_chains
void make_chains(int t){

sort(body[t],body[t]+bodov[t]);
  
lower_chain_size[t]=2;
lower_chain[t][0]=body[t][0];
lower_chain[t][1]=body[t][1];
for (int q=2;q<bodov[t];q++)
{
 while (lower_chain_size[t]>=2 && cross(
        lower_chain[t][lower_chain_size[t]-2],
        lower_chain[t][lower_chain_size[t]-1],
        body[t][q]
        )<=0) lower_chain_size[t]--;
 
 lower_chain[t][lower_chain_size[t]]=body[t][q];    
 lower_chain_size[t]++;    
}


upper_chain_size[t]=2;
upper_chain[t][0]=body[t][0];
upper_chain[t][1]=body[t][1];
for (int q=2;q<bodov[t];q++)
{
 while (upper_chain_size[t]>=2 && cross(
        upper_chain[t][upper_chain_size[t]-2],
        upper_chain[t][upper_chain_size[t]-1],
        body[t][q])>=0) upper_chain_size[t]--;
 upper_chain[t][upper_chain_size[t]]=body[t][q];    
 upper_chain_size[t]++;    
}

}
// }}}

// {{{ interval_union/intersect
tpoint interval_union(tpoint a,tpoint b){
tpoint c=a;
c.fi <?=b.fi;
c.se >?=b.se;
return c;
}

int interval_intersect(tpoint a,tpoint b){
  /*
  setcolor(WHITE);
  x+=1;
  moveto((int) x, (int) a.fi-1);
  lineto((int) x, (int) a.se+1);
  x+=1;
  
  moveto((int) x, (int) b.fi-1);
  lineto((int) x, (int) b.se+1);
  */
return !((a.se<b.fi) || (b.se<a.fi));
}
// }}}

// {{{ _get_interval
tpoint _get_interval(tpoint *chain,int pos,int size,ld x){
if (pos>=size) printf("BUG\n");
if (pos==size-1) {
  if (chain[pos].fi!=x) printf("BUGa\n");
  return mp(chain[pos].se,chain[pos].se);
}
if (chain[pos].fi>x || chain[pos+1].fi<x) printf("BUGG\n");
if (chain[pos].fi==chain[pos+1].fi) 
   return mp(chain[pos].se<?chain[pos+1].se,
             chain[pos].se>?chain[pos+1].se);

ld t;
t=(x-chain[pos].fi)/(chain[pos+1].fi-chain[pos].fi) * (
    chain[pos+1].se-chain[pos].se)+chain[pos].se;
return mp(t,t);
}
// }}}

// {{{ _intersect_test
int _intersect_test(int l0,int u0,int l1,int u1,ld x){

tpoint int1=_get_interval(lower_chain[0],l0,lower_chain_size[0],x);
tpoint int2=_get_interval(upper_chain[0],u0,upper_chain_size[0],x);
tpoint int3=_get_interval(lower_chain[1],l1,lower_chain_size[1],x);
tpoint int4=_get_interval(upper_chain[1],u1,upper_chain_size[1],x);

int t= interval_intersect(
    interval_union(int1,int2),
    interval_union(int3,int4));
return t;
}
// }}}

// {{{ intersect_test
int intersect_test(){
 if (lower_chain[0][0].fi > lower_chain[1][lower_chain_size[1]-1].fi) return 0;
 if (lower_chain[1][0].fi > lower_chain[0][lower_chain_size[0]-1].fi) return 0;
int l0=0,l1=0,u0=0,u1=0;
ld start=lower_chain[0][0].fi>?lower_chain[1][0].fi;
ld end=lower_chain[0][lower_chain_size[0]-1].fi<?
        lower_chain[1][lower_chain_size[1]-1].fi;

while (lower_chain[0][l0+1].fi < start) l0++;
while (lower_chain[1][l1+1].fi < start) l1++;
while (upper_chain[0][u0+1].fi < start) u0++;
while (upper_chain[1][u1+1].fi < start) u1++;

//printf("%d %d %d %d \n",l0,u0,l1,u1);

if (_intersect_test(l0,u0,l1,u1, start)) return 1;
// ok, mame l0,l1,u0,u1 nastavene tak
// teraz ideme preiterovat vsetko
while (start<end) {
  ld a0,a1,b0,b1;
   a0=lower_chain[0][l0+1].fi;
   b0=upper_chain[0][u0+1].fi;
   a1=lower_chain[1][l1+1].fi;
   b1=upper_chain[1][u1+1].fi;

  if (a0<b0) {
     if (a1<b1) {
       if (a0<a1) { start=a0; l0++; }
       else {start=a1; l1++;}
     } else { // a1>b1
       if (a0<b1) { start=a0; l0++; }
       else {start=b1; u1++; }
    }
  } else {
     if (a1<b1) {
       if (b0<a1) { start=b0; u0++; }
       else {start=a1; l1++;}
     } else { // a1>b1
       if (b0<b1) { start=b0; u0++; }
       else {start=b1; u1++; }
    }     
  }

  if (_intersect_test(l0,u0,l1,u1,start)) return 1;
}
  return 0;
}
// }}}

// {{{ main
int main()
{

  init();
  if ((velocity[0][0]==0) && (velocity[0][1]==0) && (velocity[0][2]==0))
     { printf("NO\n");
       return 0;
     }
  
  project();
  make_chains(0);
  make_chains(1);
  if (intersect_test())
     printf("YES\n"); else printf("NO\n");
  
 return 0;
}
// }}}
