{
  Problem C : Truth of Contest
  Author    : Yuan Hao
  Algorithm : Depth First Search
}

{$r-,q-,s-,n+,g+}
program Truth;
const
  fn_in='truth.inp';
  fn_out='truth.out';
  positive_error=0.1;
  maxn=30;
var
  ans,n,t:longint;
  w1,w2,t1,t2:array[1..maxn] of longint;
  p:array[1..maxn] of real;

  procedure init;
  var i:integer;
  begin
    assign(input,fn_in);
    reset(input);
    readln(n,t);
    for i:=1 to n do
      readln(w1[i],t1[i],w2[i],t2[i]);
    close(input);
  end;

  procedure DFS(d:integer;score,estimate:longint);
  begin
    if d>n then
    begin
      if score>ans then ans:=score;
      exit;
    end;
    if score+p[d]*estimate+positive_error<ans then exit;
    if t1[d]<=estimate then DFS(d+1,score+w1[d],estimate-t1[d]);
    if t2[d]<=estimate then DFS(d+1,score+w2[d],estimate-t2[d]);
    DFS(d+1,score,estimate);
  end;

  procedure SwapL(var i,j:longint);
  var tmp:longint;
  begin
    tmp:=i;
    i:=j;
    j:=tmp;
  end;

  procedure SwapR(var i,j:real);
  var tmp:real;
  begin
    tmp:=i;
    i:=j;
    j:=tmp;
  end;

  procedure main;
  var i,j:integer;
  begin
    for i:=1 to n do
    begin
      p[i]:=w1[i]/t1[i];
      if w2[i]/t2[i]>p[i] then p[i]:=w2[i]/t2[i];
    end;
    for i:=1 to n do
     for j:=i+1 to n do
      if p[i]<p[j] then
      begin
        SwapL(w1[i],w1[j]);
        SwapL(w2[i],w2[j]);
        SwapL(t1[i],t1[j]);
        SwapL(t2[i],t2[j]);
        SwapR(p[i],p[j]);
      end;
    ans:=0;
    DFS(1,0,t);
  end;

  procedure out;
  begin
    assign(output,fn_out);
    rewrite(output);
    writeln(ans);
    close(output);
  end;

  begin
    init;
    main;
    out;
  end.

