program A;
const
     MAXN=2*12+2;
     MAXREAL=1000000;
type
    dtype=record
          f,c:integer;
          w:extended;
          end;
    ptype=record
          p,d:integer; {p:pre node}
          ct:extended;
          end;
    pway=array[1..MAXN]of ptype;
    dnet=array[1..MAXN,1..MAXN]of dtype;
    point=record
          x,y:integer;
          end;
var
   d:dnet;
   n,s,t:integer;
   p:array[1..MAXN*2]of point;

procedure Setfiles(inputpath,outputpath:string);
begin
close(input);
assign(input,inputpath);
reset(input);
close(output);
assign(output,outputpath);
rewrite(output);
end;

function Getd(a,b:point):extended;
begin
Getd:=sqrt((b.x-a.x)*(b.x-a.x)+(b.y-a.y)*(b.y-a.y));
end;

procedure Insert(u,v,c:integer; w:extended);
begin
d[u,v].c:=c; d[u,v].f:=0; d[u,v].w:=w;
d[v,u].c:=0; d[v,u].f:=0; d[v,u].w:=-w;
end;

procedure Init;
var
   i,j:integer;

begin
readln(n);
fillchar(d,sizeof(d),0);

for i:=1 to 2*n do readln(p[i].x,p[i].y);

for i:=1 to n do
    for j:=n+1 to 2*n do
        Insert(i,j,1,Getd(p[i],p[j]));

s:=2*n+1; t:=2*n+2;
for i:=1 to n do Insert(s,i,1,0);
for i:=n+1 to 2*n do Insert(i,t,1,0);
n:=t;
end;

procedure Ford;
var
   cost:extended;
   a,i,j:integer;
   path:pway;
   break:boolean;
begin
cost:=0;
repeat
      for i:=1 to n do begin
          path[i].ct:=MAXREAL;
          path[i].p:=0;
          end;
      path[s].d:=MAXINT;
      path[s].p:=s;
      path[s].ct:=0;
      repeat
            break:=true;
            for i:=1 to n do
                for j:=1 to n do begin
                    a:=d[i,j].c-d[i,j].f;
                    if (a>0) and (path[i].ct<MAXREAL) and
                       (path[i].ct+d[i,j].w<path[j].ct) then begin
                       break:=false;
                       path[j].ct:=path[i].ct+d[i,j].w;
                       path[j].p:=i;
                       if a<path[i].d then path[j].d:=a
                       else path[j].d:=path[i].d;
                       end;
                    end;
      until break;

      if path[t].p<>0 then begin
         i:=t;
         a:=path[i].d;
         repeat
               cost:=cost+a*d[path[i].p,i].w;
               inc(d[path[i].p,i].f,a);
               d[i,path[i].p].f:=-d[path[i].p,i].f;
               i:=path[i].p;
         until i=s;
         end;
until path[t].p=0;

writeln(cost:0:3);
end;

begin
Init;
Ford;
end.
