#include <stdio.h>
#include <string.h>
#define MAX 100

class Tequation {
	int height, width, mid;
	char figure[MAX][MAX];

	public:
		Tequation() {
			height=width=mid=0;
			memset(figure, 0, sizeof(figure));
		}

		Tequation(char str[]) {
			Init(str);
		}

		void Init(char str[]) {
			memset(figure, 0, sizeof(figure));

			strcpy(figure[0], str);
			height=1; width=(int)strlen(str);
			mid=0;
		}

		Tequation AddBracket() {
			Tequation res;

			for ( int i=0; i<height; ++i ) {
				res.figure[i][0]='(';
				strcpy(&res.figure[i][1], figure[i]);
				res.figure[i][width+1]=')';
			}
			res.height=height; res.width=width+2; res.mid=mid;

			return res;
		}

		Tequation Connect(Tequation x, char oper) {
			Tequation res;

			if ( mid<x.mid ) {
				for ( int i=0; i<height; ++i )
					strcpy(res.figure[x.mid-mid+i], figure[i]);
				for ( int i=0; i<x.mid-mid; ++i )
					memset(res.figure[i], ' ', width);

				res.height=height+x.mid-mid; res.width=width;
				res.mid=x.mid;
			}
			else
				res=*this;

			res.figure[res.mid][res.width+1]=oper;
			if ( res.mid-x.mid+x.height>res.height )
				res.height=res.mid-x.mid+x.height;
			res.width=width+3;

			for ( int i=0; i<x.height; ++i )
				for ( int j=0; j<x.width; ++j )
					res.figure[res.mid-x.mid+i][res.width+j]=x.figure[i][j];
			res.width+=x.width;

			for ( int i=0; i<res.height; ++i )
				for ( int j=0; j<res.width; ++j )
					if ( res.figure[i][j]==0 )
						res.figure[i][j]=' ';

			return res;
		}

		Tequation Power(Tequation x) {
			Tequation res;

			for ( int i=0; i<x.height; ++i ) {
				memset(res.figure[i], ' ', width);
				strcpy(&res.figure[i][width], x.figure[i]);
			}
			for ( int i=0; i<height; ++i ) {
				strcpy(res.figure[x.height+i], figure[i]);
				memset(&res.figure[x.height+i][width], ' ', x.width);
			}

			res.height=x.height+height; res.width=width+x.width;
			res.mid=x.height+mid;

			return res;
		}

		Tequation Divide(Tequation x) {
			Tequation res;
			int d1, d2;

			if ( width>x.width ) {
				d1=0, d2=(width-x.width+1)>>1;
				res.width=width;
			}
			else {
				d1=(x.width-width+1)>>1, d2=0;
				res.width=x.width;
			}

			for ( int i=0; i<height; ++i ) {
				memset(res.figure[i], ' ', d1);
				strcpy(&res.figure[i][d1], figure[i]);
				memset(&res.figure[i][d1+width], ' ', res.width-d1-width);
			}
			for ( int i=0; i<res.width; ++i )
				res.figure[height][i]='-';
			for ( int i=0; i<x.height; ++i ) {
				memset(res.figure[height+1+i], ' ', d2);
				strcpy(&res.figure[height+1+i][d2], x.figure[i]);
				memset(&res.figure[height+1+i][d2+x.width], ' ', res.width-d2-x.width);
			}

			res.height=height+x.height+1;
			res.mid=height;
		
			return res;
		}

		void Print() {
			for ( int i=0; i<height; ++i ) {
				for ( int j=0; j<width; ++j )
					putchar(figure[i][j]);
				putchar('\n');
			}
		}
};

void process(int L, int R);
Tequation res;
Tequation stack[100];
int top = -1;

char equ[260];

int main() {
	// freopen("equprint.in", "r+", stdin);
	// freopen("equprint.out", "w+", stdout);

	scanf("%s", equ);
	process(0, (int)strlen(equ)-1);
	res.Print();

	// fclose(stdin);
	// fclose(stdout);

	return 0;
}

void process(int L, int R) {
	if ( L==R ) {
		char s[5];
		memset(s, 0, sizeof(s));
		s[0]=equ[L];

		res.Init(s);
	}

	int best = 99, pos = -1;
	int level = 0;

	for ( int i=L; i<=R; ++i )
		if ( equ[i]=='(' || equ[i]=='{' )
			++level;
		else if ( equ[i]==')' || equ[i]=='}' )
			--level;
		else if ( level==0 ) {
			if ( equ[i]=='^' && best>=2 )
				best=2, pos=i;
			else if ( (equ[i]=='*' || equ[i]=='/') && best>=1 )
				best=1, pos=i;
			else if ( equ[i]=='+' || equ[i]=='-' )
				best=0, pos=i;
		}

	if ( pos<0 ) {
		if ( equ[L]=='{' )
			process(L+1, R-1);
		else if ( equ[L]=='(' ) {
			process(L+1, R-1);
			res=res.AddBracket();
		}
		else {
			char s[MAX+5];
			memset(s, 0, sizeof(s));
			strncpy(s, &equ[L], R-L+1);

			res.Init(s);
		}
		return;
	}

	process(pos+1, R);
	stack[++top] = res;
	process(L, pos-1);

	if ( equ[pos]=='^' )
		res=res.Power(stack[top]);
	else if ( equ[pos]=='/' )
		res=res.Divide(stack[top]);
	else
		res=res.Connect(stack[top], equ[pos]);

	--top;
}