{$Q-,R-}
program Block;
const
  Max                   = 12;
  MaxAns                = 70000;
  dx                    : array [1..4] of Integer
                        = (-1, 0, 0, 1);
  dy                    : array [1..4] of Integer
                        = (0, -1, 1, 0);
type
  TMatrix               = array [1..(Max+1) shr 1, 1..Max] of Integer;
  TRes                  = array [1..Max] of Byte;
var
  Map, Degree           : TMatrix;
  Res                   : TRes;
  n, half, Level        : Integer;
  Size                  : Longint;

  { AVL Tree }
  Total                 : Longint;
  Item                  : array [1..MaxAns] of TRes;
  Pre, LCh, RCh         : array [0..MaxAns] of Longint;
  Balance               : array [1..MaxAns] of Shortint;

  { Transport }
  Tmp                   : TRes;

  { Timer }
  Checked               : Longint;

function BSearch: Boolean;
var
  i, j                  : Longint;

begin
  Inc(Checked);

  i:=RCh[0];

  repeat
    j:=CompareByte(Tmp, Item[i], Size);

    if j=0 then begin
      BSearch:=true;
      exit;
    end;

    if j>0 then
      if RCh[i]=0 then
        break
      else
        i:=RCh[i]
    else
      if LCh[i]=0 then
        break
      else
        i:=LCh[i];
  until false;

  BSearch:=false;
end;

procedure Process(height, width: Integer);
var
  n1, n2, n3, n4        : Integer;

  s                     : Longint;
  i, j, k               : Longint;
  Left                  : Boolean;

begin
  { Direction #1 }
  n1:=0; n2:=0;
  for i:=1 to height do begin
    if Map[i, 1]=1 then
      Inc(n1);
    if Map[i, width]=1 then
      Inc(n2);
  end;
  if n1<n2 then
    exit;

  { Direction #2 }
  n3:=0; n4:=0;
  for i:=1 to width do begin
    if Map[1, i]=1 then
      Inc(n3);
    if Map[height, i]=1 then
      Inc(n4);
  end;
  if n3<n4 then
    exit;

  { Direction #3 }
  if ( height=width ) and ( n3<n1 ) then
    exit;

  if Total=0 then begin
    Total:=1;
    Item[1]:=Res;
    RCh[0]:=1;

    exit;
  end;

  {0d}
  if n1=n2 then begin
    k:=0;
    for i:=1 to height do
      for j:=1 to width do
        if Map[i, width+1-j]=1 then begin
          Inc(k);
          Tmp[k]:=i shl 4+j;
        end;

    if BSearch then
      exit;
  end;

  {90d}
  if height=width then begin
    if ( n3=n4 ) and ( n1=n4 ) then begin
      k:=0;
      for i:=1 to width do
        for j:=1 to height do
          if Map[height+1-j, i]=1 then begin
            Inc(k);
            Tmp[k]:=i shl 4+j;
          end;

      if BSearch then
        exit;
    end;

    if n1=n3 then begin
      k:=0;
      for i:=1 to width do
        for j:=1 to height do
          if Map[j, i]=1 then begin
            Inc(k);
            Tmp[k]:=i shl 4+j;
          end;

      if BSearch then
        exit;
    end;
  end;

  {180d}
  if n3=n4 then begin
    if n1=n2 then begin
      k:=0;
      for i:=1 to height do
        for j:=1 to width do
          if Map[height+1-i, width+1-j]=1 then begin
            Inc(k);
            Tmp[k]:=i shl 4+j;
          end;

      if BSearch then
        exit;
    end;

    k:=0;
    for i:=1 to height do
      for j:=1 to width do
        if Map[height+1-i, j]=1 then begin
          Inc(k);
          Tmp[k]:=i shl 4+j;
        end;

    if BSearch then
      exit;
  end;

  {270d}
  if ( height=width ) and ( n1=n2 ) and ( n1=n3 ) then begin
    k:=0;
    for i:=1 to width do
      for j:=1 to height do
        if Map[j, height+1-i]=1 then begin
          Inc(k);
          Tmp[k]:=i shl 4+j;
        end;

    if BSearch then
      exit;

    if n3=n4 then begin
      k:=0;
      for i:=1 to width do
        for j:=1 to height do
          if Map[width+1-j, height+1-i]=1 then begin
            Inc(k);
            Tmp[k]:=i shl 4+j;
          end;

      if BSearch then
        exit;
    end;
  end;

  s:=RCh[0]; i:=s;

  repeat
    if Balance[i]<>0 then
      s:=i;

    if CompareByte(Res, Item[i], Size)>0 then
      if RCh[i]=0 then begin
        Left:=false;
        break;
      end
      else
        i:=RCh[i]
    else
      if LCh[i]=0 then begin
        Left:=true;
        break;
      end
      else
        i:=LCh[i];
  until false;

  Inc(Total);
  Item[Total]:=Res;
  Pre[Total]:=i;

  if Left then
    LCh[i]:=Total
  else
    RCh[i]:=Total;

  j:=Total; k:=-1;
  while i<>s do begin
    if LCh[i]=j then
      Balance[i]:=1
    else
      Balance[i]:=-1;

    k:=j; j:=i; i:=Pre[i];
  end;
  if LCh[i]=j then
    Inc(Balance[i])
  else
    Dec(Balance[i]);

  if Abs(Balance[i])>1 then
    if ( LCh[i]=j ) and ( LCh[j]=k ) then begin
      { LL }
      Pre[j]:=Pre[i];
      if LCh[Pre[i]]=i then
        LCh[Pre[i]]:=j
      else
        RCh[Pre[i]]:=j;

      LCh[i]:=RCh[j];
      if RCh[j]>0 then
        Pre[RCh[j]]:=i;

      RCh[j]:=i; Pre[i]:=j;

      Balance[i]:=0; Balance[j]:=0;
    end
    else if ( LCh[i]=j ) and ( RCh[j]=k ) then begin
      { LR }
      Pre[k]:=Pre[i];
      if LCh[Pre[i]]=i then
        LCh[Pre[i]]:=k
      else
        RCh[Pre[i]]:=k;

      RCh[j]:=LCh[k];
      if LCh[k]>0 then
        Pre[LCh[k]]:=j;
      LCh[i]:=RCh[k];
      if RCh[k]>0 then
        Pre[RCh[k]]:=i;

      LCh[k]:=j; Pre[j]:=k;
      RCh[k]:=i; Pre[i]:=k;

      if Balance[k]=1 then begin
        Balance[j]:=0; Balance[i]:=-1;
      end
      else if Balance[k]=-1 then begin
        Balance[j]:=1; Balance[i]:=0;
      end
      else begin
        Balance[i]:=0; Balance[j]:=0;
      end;

      Balance[k]:=0;
    end
    else if ( RCh[i]=j ) and ( LCh[j]=k ) then begin
      { RL }
      Pre[k]:=Pre[i];
      if LCh[Pre[i]]=i then
        LCh[Pre[i]]:=k
      else
        RCh[Pre[i]]:=k;

      RCh[i]:=LCh[k];
      if LCh[k]>0 then
        Pre[LCh[k]]:=i;
      LCh[j]:=RCh[k];
      if RCh[k]>0 then
        Pre[RCh[k]]:=j;

      LCh[k]:=i; Pre[i]:=k;
      RCh[k]:=j; Pre[j]:=k;

      if Balance[k]=1 then begin
        Balance[i]:=0; Balance[j]:=-1;
      end
      else if Balance[k]=-1 then begin
        Balance[i]:=1; Balance[j]:=0;
      end
      else begin
        Balance[i]:=0; Balance[j]:=0;
      end;

      Balance[k]:=0;
    end
    else begin
      { RR }
      Pre[j]:=Pre[i];
      if LCh[Pre[i]]=i then
        LCh[Pre[i]]:=j
      else
        RCh[Pre[i]]:=j;

      RCh[i]:=LCh[j];
      if LCh[j]>0 then
        Pre[LCh[j]]:=i;

      LCh[j]:=i; Pre[i]:=j;

      Balance[i]:=0; Balance[j]:=0;
    end;
end;

procedure Try(height, width: Integer);
var
  i, j, k               : Longint;
  x, y                  : Integer;

  Pass                  : Boolean;

begin
  if Level>n then begin
    if height<=width then begin
      Pass:=false;
      for i:=1 to half do
        if Map[i, 1]=1 then begin
          Pass:=true;
          break;
        end;

      if Pass then begin
        k:=0;
        for i:=1 to half do
          for j:=1 to n do
            if Map[i, j]=1 then begin
              Inc(k);
              Res[k]:=i shl 4+j;
            end;

        Process(height, width);
      end;
    end;

    exit;
  end;

  for i:=1 to half do
    for j:=1 to n do
      if ( Map[i, j]=0 ) and ( Degree[i, j]>0 ) then begin
        Map[i, j]:=1;
        for k:=1 to 4 do begin
          x:=i+dx[k]; y:=j+dy[k];
          if ( x>0 ) and ( x<=half ) and ( y>0 ) and ( y<=n ) then
            Inc(Degree[x, y]);
        end;

        Inc(Level);
        if i>height then x:=i
                    else x:=height;
        if j>width then y:=j
                   else y:=width;
        Try(x, y);
        Dec(Level);

        Map[i, j]:=-Level;
        for k:=1 to 4 do begin
          x:=i+dx[k]; y:=j+dy[k];
          if ( x>0 ) and ( x<=half ) and ( y>0 ) and ( y<=n ) then
            Dec(Degree[x, y]);
        end;
      end;

  for i:=1 to half do
    for j:=1 to n do
      if Map[i, j]=-Level then
        Map[i, j]:=0;
end;

procedure Solve;
var
  i, j, x, y            : Longint;
  last                  : Integer;

begin
  Fillchar(Map, Sizeof(Map), 0);
  Fillchar(Degree, Sizeof(Degree), 0);

  Fillchar(Item, Sizeof(Item), 0);
  Fillchar(Pre, Sizeof(Pre), 0);
  Fillchar(LCh, Sizeof(LCh), 0);
  Fillchar(RCh, Sizeof(RCh), 0);
  Fillchar(Balance, Sizeof(Balance), 0);

  if n=2 then
    last:=1
  else
    last:=n-2;

  for i:=1 to last do begin
    Map[1, i]:=1;
    for j:=1 to 4 do begin
      x:=1+dx[j]; y:=i+dy[j];
      if ( x>0 ) and ( x<=half ) and ( y>0 ) and ( y<=n ) then
        Inc(Degree[x, y]);
    end;

    Level:=2;
    Try(1, i);

    Map[1, i]:=-1;
    for j:=1 to 4 do begin
      x:=1+dx[j]; y:=i+dy[j];
      if ( x>0 ) and ( x<=half ) and ( y>0 ) and ( y<=n ) then
        Dec(Degree[x, y]);
    end;
  end;
end;

{ Main }
begin
  Readln(n);
  if n=1 then
    Writeln(1)
  else begin
    half:=(n+1) shr 1;
    Size:=Sizeof(Res[1])*n;

    Solve;
    Writeln(Total);
  end;
end.
