const
  infile  ='sramoc.dat';
  outfile ='sramoc.out';

var
  data,
  fa	  :array [0..1000] of longint;
  n,p	  :longint;

procedure init;
var i:longint;
begin
  assign(input,infile); reset(input);
    readln(n,p);
    for i:=0 to p do
      fa[i]:=-1;
  close(input);
  if n>p then
     begin
       assign(output,outfile); rewrite(output);
         writeln(p);
       close(output);
       halt;
     end;
end;

procedure work;
var i:longint;
    queue:array [1..1000] of longint;
    head,tail,tmp:longint;
begin
  head:=1; tail:=0;
  for i:=1 to n-1 do
    begin
      data[i]:=i;
      fa[i]:=-2;
      inc(tail);
      queue[tail]:=i;
    end;

  repeat
    for i:=0 to n-1 do
      begin
        tmp:=(queue[head]*10+i) mod p;
        if fa[tmp]=-1 then
           begin
             inc(tail);
             queue[tail]:=tmp;
             data[tmp]:=i;
             fa[tmp]:=queue[head];
           end;
      end;
    inc(head);
  until fa[0]<>-1;
end;

procedure out;
var key:array [1..1000] of longint;
    p,len,i:longint;
begin
  p:=0; len:=0;
  while p<>-2 do
    begin
      inc(len);
      key[len]:=data[p];
      p:=fa[p];
    end;
  assign(output,outfile); rewrite(output);
    for i:=len downto 1 do
       write(key[i]);
    writeln;
  close(output);
end;

begin
  init;
  work;
  out;
end.