{$R-,Q-,S-}
Const
    InFile	= 'rational.dat';
    OutFile	= 'rational.out';

Type
    Tnumber	= record
                     p , q	: longint;
    	  end;

Var
    smaller ,
    larger	: Tnumber;
    P , N	: longint;
    sqrtnumber	: extended;

procedure init;
begin
    assign(INPUT , InFile); ReSet(INPUT);
      readln(P , N);
    Close(INPUT);
    fillchar(smaller , sizeof(smaller) , 0);
    fillchar(larger , sizeof(larger) , 0);
    sqrtnumber := sqrt(P);
end;

procedure find(mid : extended; var num : Tnumber; sign : longint);
var
    i , tmp	: longint;
    min_dist	: extended;
begin
    min_dist := -1;
    for i := 1 to N do
      begin
          tmp := trunc(i * mid) + sign;
          if tmp > N then
            if sign = 0 then
              tmp := N
            else
              break;
          if (min_dist < 0) or (abs(mid - tmp / i) < min_dist) then
            begin
                min_dist := abs(mid - tmp / i);
                num.p := tmp;
                num.q := i;
            end;
      end;
end;

function gcd(p , q : longint) : longint;
begin
    if p = 0 then
      gcd := q
    else
      gcd := gcd(q mod p , p);
end;

procedure reduction(var num : Tnumber);
var
    tmp	: longint;
begin
    tmp := gcd(num.p , num.q);
    num.p := num.p div tmp;
    num.q := num.q div tmp;
end;

procedure work;
begin
    find(sqrtnumber , smaller , 0);
    find(sqrtnumber , larger , 1);
    reduction(smaller);
    reduction(larger);
end;

procedure out;
begin
    assign(OUTPUT , OutFile); ReWrite(OUTPUT);
      writeln(smaller.p , '/' , smaller.q , ' ' , larger.p , '/' , larger.q);
    Close(OUTPUT);
end;

Begin
    init;
    work;
    out;
End.