Program escape;
 const
   inputfilename='escape.in';
   outputfilename='escape.out';
   maxn=40;
   d:array[1..4,1..2] of shortint=((1,0),(0,-1),(-1,0),(0,1));
 type
   Tpoint=record x,y:byte; end;
   Tmap=array[1..maxn,1..maxn] of integer;
   Tstack=array[1..maxn*maxn] of Tpoint;
 var
   map:Tmap;
   n,m,apples,step:integer;
   s,t,now:Tpoint;
   stack,stack1:Tstack;
   snum,snum1:integer;

procedure readdata;
 var
   i,j:integer;
   st:string;
   ch:char;
begin
  fillchar(map,sizeof(map),0);
  assign(input,inputfilename);
  reset(input);
  readln(n,m);
  readln(s.x,s.y,t.x,t.y);
  readln(apples);
  for i:=1 to n do
   begin
     readln(st);
     for j:=1 to length(st) do
      begin
        ch:=st[j];
        case ch of
          '^':map[i,j]:=-3;
          '>':map[i,j]:=-4;
          'V':map[i,j]:=-1;
          '<':map[i,j]:=-2;
          '0':map[i,j]:=21;
        end;
      end;
   end;
  close(input);
end;

procedure prepare;
 var
   i,j,xx,yy:integer;
begin
  for i:=1 to n do
   for j:=1 to m do
    if map[i,j]<0 then
     begin
       xx:=i+d[-map[i,j],1];
       yy:=j+d[-map[i,j],2];
       if (xx>=1) and (xx<=n) and (yy>=1) and (yy<=m) then
        if map[xx,yy]=0 then map[xx,yy]:=22;
     end;
  for i:=1 to n do for j:=1 to m do if map[i,j]<0 then map[i,j]:=21;
end;

procedure print;
 begin
   assign(output,outputfilename);
   rewrite(output);
   if step>apples then writeln('Bob lost his life in the forest.')
    else writeln(step);
   close(output);
   halt;
 end;

procedure extend(x,y:integer);
 var
   i:integer;
   p:Tpoint;
begin
  for i:=1 to 4 do
   begin
     p.x:=x+d[i,1]; p.y:=x+d[i,2];
     if (p.x>=1) and (p.x<=n) and (p.y>=1) and (p.y<=m) then
      if map[p.x,p.y]=0 then
       begin
         map[p.x,p.y]:=step;
         extend(p.x,p.y);
       end
      else if map[p.x,p.y]=22 then {it is controlled by flower}
       begin
         map[p.x,p.y]:=step;
         inc(snum1); stack[snum1]:=p;
       end;
   end;
end;

procedure main;
 var
   i:integer;
begin
  fillchar(stack,sizeof(stack),0);
  fillchar(stack1,sizeof(stack1),0);
  if map[s.x,s.y]<>0 then begin step:=100; print; end;
  step:=0; snum:=1; snum1:=0;
  stack[1].x:=s.x; stack[1].y:=s.y;
  while map[t.x,t.y]=0 do
   begin
     inc(step); if step>apples+1 then break;
     for i:=1 to snum do
      begin
        now:=stack[i];
        map[now.x,now.y]:=step;
        extend(now.x,now.y);
      end;
     stack:=stack1; snum:=snum1; snum1:=0;
   end;
  dec(step);
end;

Begin
  readdata;
  prepare;
  main;
  print;
End.
