#include<iostream.h>
#include<fstream.h>
#include<string.h>

#define maxn 30005

int a[maxn],mk[maxn];

void GetLoopInfo(int n,int m,int &p,int &q)
{
	memset(mk,0,sizeof(int)*m);
	for(int i=1,j=n%m;;i++,j=(j*n)%m)
		if(mk[j]==0) mk[j]=i; else 	{ p=mk[j]; q=i;	return; }
}

int IsDirectCalcNeeded(int i,int n)
{
	if(n==2 && i<=4) return 1;
	if(n<=6 && i<=2) return 1;	
	return 0;
}

int Tower(int k,int n) // n^n^....  
{
	if(k==1) return n;
	int i,j,up=Tower(k-1,n);
	for(i=1,j=1 ;i<=up; i++) j=j*n;
	return j;
}

int Solve(int i,int n,int m) // n^a[i-1] mod m
{
	int j,k,up;
	if(i==2){  // calc n^n mod m
		for(k=1,j=1; j<=n; j++) k=(k*n)%m;
		return k;	
	}
	if( IsDirectCalcNeeded(i-1,n) ){
		up=Tower(i-1,n);
		for(k=1,j=1; j<=up; j++) k=(k*n)%m;
		return k;
	}
	int p,q;
	GetLoopInfo(n,m,p,q);
	up=q + (Solve(i-1,n,q-p)-p)%(q-p);
	for(k=1,j=1; j<=up; j++) k=(k*n)%m;
	return k;
}

int main()
{
	ifstream cin("a.dat");
	ofstream cout("a.out");
	int n,m;  cin>>n>>m;
	if(n==1) cout<< 1%m<<endl;
		else cout<<Solve(n,n,m)<<endl;
	return 0;
}
