{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{ Time Complexity : O(K * N*N*K*log(N*K)) }

{ Cautare liniara + Dijkstra cu heap }

Program _lanterna_;

const filein = 'lanterna.in';
      fileout = 'lanterna.out';
      MAXN = 50;
      MAXK = 1000;
      infinit = 30000;
      maxdim1 = 63;

type linie = array [0..MAXK] of integer;
     plinie = ^linie;
     linieheapN = array [0..MAXK] of byte;
     plinieheapN = ^linieheapN;
     linieheapK = array [0..MAXK] of integer;
     plinieheapK = ^linieheapK;
     liniepoz = array [0..MAXK] of word;
     pliniepoz = ^liniepoz;

var T, W : array [1..MAXN, 1..MAXN] of integer;
    Tmin : array [1..MAXN] of plinie;
    charge : array [1..MAXN] of boolean;
    i, j, p, M, N, K, dimheap : integer;
    heapN : array [0..maxdim1] of plinieheapN;
    heapK : array [0..maxdim1] of plinieheapK;
    poz : array [1..MAXN] of pliniepoz;
    TOK, bestK : integer;

procedure readdata;
begin
assign(input, filein);
reset(input);
read(N, K);

for i := 1 to N do
  begin
    read(p);
    charge[i] := (p = 1);
  end;

read(M);

for i := 1 to N do
  for j := 1 to N do
    begin
      T[i,j] := infinit;
      W[i,j] := MAXK + 1;
    end;

for p := 1 to m do
  begin
    read(i, j);
    read(T[i,j], W[i,j]);
    T[j,i] := T[i,j];
    W[j,i] := W[i,j];
  end;

close(input);

for i := 1 to N do
  begin
    new(Tmin[i]);
    new(poz[i]);
  end;

for i := 0 to maxdim1 do
  begin
    new(heapN[i]);
    new(heapK[i]);
  end;
end;

procedure writedata;
begin
assign(output, fileout);
rewrite(output);
writeln(TOK, ' ', bestK);
close(output);
end;

procedure up(po : word);
var tata : word;
    ipo, kpo, itata, ktata : integer;

begin
ipo := heapN[po and 63]^[po shr 6];
kpo := heapK[po and 63]^[po shr 6];

tata := po shr 1;
itata := heapN[tata and 63]^[tata shr 6];
ktata := heapK[tata and 63]^[tata shr 6];

while (tata > 0) and (Tmin[itata]^[ktata] > Tmin[ipo]^[kpo]) do
  begin
    heapN[po and 63]^[po shr 6] := itata;
    heapK[po and 63]^[po shr 6] := ktata;
    heapN[tata and 63]^[tata shr 6] := ipo;
    heapK[tata and 63]^[tata shr 6] := kpo;

    poz[itata]^[ktata] := po;
    poz[ipo]^[kpo] := tata;

    po := tata;

    tata := po shr 1;
    itata := heapN[tata and 63]^[tata shr 6];
    ktata := heapK[tata and 63]^[tata shr 6];
  end;
end;

procedure down(po : word);
var p1, p2 : word;
    ip1, kp1, ip2, kp2, ipo, kpo : integer;
    ok : boolean;

begin
ok := false;
while (not ok) do
  begin
    ok := true;

    ipo := heapN[po and 63]^[po shr 6];
    kpo := heapK[po and 63]^[po shr 6];

    p1 := 2*po;
    if (p1 <= dimheap) then
      begin
        ip1 := heapN[p1 and 63]^[p1 shr 6];
        kp1 := heapK[p1 and 63]^[p1 shr 6];
      end
    else
      begin
        ip1 := ipo;
        kp1 := kpo;
      end;

    p2 := 2*po + 1;
    if (p2 <= dimheap) then
      begin
        ip2 := heapN[p2 and 63]^[p2 shr 6];
        kp2 := heapK[p2 and 63]^[p2 shr 6];
      end
    else
      begin
        ip2 := ipo;
        kp2 := kpo;
      end;

    if (Tmin[ip1]^[kp1] <= Tmin[ip2]^[kp2]) and (Tmin[ip1]^[kp1] < Tmin[ipo]^[kpo]) then
      begin
        heapN[po and 63]^[po shr 6] := ip1;
        heapK[po and 63]^[po shr 6] := kp1;
        heapN[p1 and 63]^[p1 shr 6] := ipo;
        heapK[p1 and 63]^[p1 shr 6] := kpo;

        poz[ip1]^[kp1] := po;
        poz[ipo]^[kpo] := p1;

        po := p1;
        ok := false;
      end
    else
    if (Tmin[ip2]^[kp2] <= Tmin[ip1]^[kp1]) and (Tmin[ip2]^[kp2] < Tmin[ipo]^[kpo]) then
      begin
        heapN[po and 63]^[po shr 6] := ip2;
        heapK[po and 63]^[po shr 6] := kp2;
        heapN[p2 and 63]^[p2 shr 6] := ipo;
        heapK[p2 and 63]^[p2 shr 6] := kpo;

        poz[ip2]^[kp2] := po;
        poz[ipo]^[kpo] := p2;

        po := p2;
        ok := false;
      end;
  end;
end;

procedure insert(i, j : integer);
begin
inc(dimheap);

heapN[dimheap and 63]^[dimheap shr 6] := i;
heapK[dimheap and 63]^[dimheap shr 6] := j;
poz[i]^[j] := dimheap;

up(dimheap);
end;

procedure deletemin;
begin
dec(dimheap);

if (dimheap > 0) then
  begin
    heapN[1]^[0] := heapN[(dimheap+1) and 63]^[(dimheap+1) shr 6];
    heapK[1]^[0] := heapK[(dimheap+1) and 63]^[(dimheap+1) shr 6];

    down(1);
  end;
end;

function MinT(kmax : integer) : integer;
var i, j, k, p, q, tN : integer;

begin
for i := 1 to N do
  for j := 0 to kmax do
    begin
      Tmin[i]^[j] := infinit;
      poz[i]^[j] := 0;
    end;

Tmin[1]^[0] := 0;

dimheap := 1;
heapN[1]^[0] := 1;
heapK[1]^[0] := 0;

tN := infinit;

while (dimheap >= 1) do
  begin
    i := heapN[1]^[0];
    k := heapK[1]^[0];

    if (Tmin[i]^[k] < tN) then
      for j := 1 to N do
        if (T[i,j] < infinit) and (k + W[i,j] <= kmax) then
          begin
            p := Tmin[i]^[k] + T[i,j];
            q := k + W[i,j];

            if (charge[j]) then
              q := 0;

            if (p < Tmin[j]^[q]) then
              begin
                Tmin[j]^[q] := p;

                if (j = N) and (Tmin[j]^[q] < tN) then
                  tN := Tmin[j]^[q];

                if (Tmin[j]^[q] < tN) then
                  begin
                    if (poz[j]^[q] = 0) then
                      insert(j, q)
                    else
                      up(poz[j]^[q]);
                  end;
              end;
          end;

    deletemin;
  end;

MinT := tN;
end;

begin
readdata;

TOK := MinT(K);
bestK := K;

for p := K-1 downto 1 do
  if (MinT(p) = TOK) then
    bestK := p
  else
    break;

writedata;
end.