/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* Time Complexity : O(N*logN + N) */

#include <stdio.h>
#include <string.h>
#include <math.h>
#define filein "MOSIA.IN"
#define fileout "MOSIA.OUT"
#define maxn 210
#define maxim(a,b) (a > b ? (a) : (b))

int x[maxn], y[maxn], xo[maxn], yo[maxn], d[maxn];
int o[maxn], oaux[maxn], inside[maxn], stack[maxn];
double v[maxn], max[maxn][2], best1, best2;
int i, j, k, m, p, smn, a, b, c, N;

double dist2d(double xa, double ya, double xb, double yb)
{
return sqrt((xa-xb)*(xa-xb) + (ya-yb)*(ya-yb));
}

int semn(long int a, long int b, long int c, long int x, long int y)
{
long int r = a*x + b*y + c;

if (r == 0) return 0;
else
  if (r > 0) return 1;
else
  return -1;
}

void sort(int li, int ls)
{
if (ls > li)
  {
    sort(li, (li+ls)>>1);
    sort(((li+ls)>>1)+1, ls);

    k = li-1;
    i = li;
    m = (li+ls)>>1;
    j = m+1;

    while (i <= m && j <= ls)
      {
        k++;

        if (x[o[i]] < x[o[j]] ||
           (x[o[i]] == x[o[j]] && y[o[i]] < y[o[j]]))
          {
            oaux[k]=o[i];
            i++;
          }
        else
          {
            oaux[k]=o[j];
            j++;
          }
      }

    if (i <= m)
      {
        for (j = i; j <= m; j++)
          {
            k++;
            oaux[k] = o[j];
          }
      }
    else
      {
        for (i = j; i <= ls; i++)
          {
            k++;
            oaux[k] = o[i];
          }
      }

    for (k = li; k <= ls; k++)
      o[k] = oaux[k];
  }
}

int main()
{
/* citeste datele de intrare */

freopen(filein, "r", stdin);
scanf("%d", &N);
for (i = 1; i <= N; i++)
  scanf("%d %d %d", &x[i], &y[i], &d[i]);

/* orienteaza parii in ordinea de pe infasuratoarea convexa */
for (i = 1; i <= N; i++)
  o[i] = i;

sort(1, N);

memset(inside, 0, sizeof(inside));
stack[1] = 1; stack[2] = 2; inside[2]=1; i = 2;

/* Step 1 */
for (p = 3; p <= N; p++)
  {
    if (x[o[p]] == x[o[stack[i]]] && y[o[p]] == y[o[stack[i]]])
      continue;

    smn = -1;
    while (smn<0)
      {
        if (i == 1)
          {
            i++;
            stack[i] = p;
            inside[p] = 1;
            smn = 0;
          }
        else
          {
            a = y[o[stack[i-1]]]-y[o[stack[i]]];
            b = x[o[stack[i]]]-x[o[stack[i-1]]];
            c = x[o[stack[i-1]]]*y[o[stack[i]]]-x[o[stack[i]]]*y[o[stack[i-1]]];

            smn = semn(a,b,c,x[o[p]],y[o[p]]);

            if (smn >= 0)
	            {
	              i++;
	              stack[i] = p;
	              inside[p] = 1;
	            }
            else
	            {
	              inside[stack[i]] = 0;
	              i--;
	            }
          }
      }
  }

/* Step 2 */
for (p = N; p >= 1; p--)
  if (!inside[p])
    {
      if (x[o[p]] == x[o[stack[i]]] && y[o[p]] == y[o[stack[i]]])
        continue;

      smn = -1;
      while (smn < 0)
        {
          if (i==1)
	          {
	            i++;
	            stack[i] = p;
	            inside[p] = 1;
	            smn = 0;
	          }
          else
	          {
	            a = y[o[stack[i-1]]]-y[o[stack[i]]];
	            b = x[o[stack[i]]]-x[o[stack[i-1]]];
	            c = x[o[stack[i-1]]]*y[o[stack[i]]]-x[o[stack[i]]]*y[o[stack[i-1]]];

	            smn = semn(a,b,c,x[o[p]],y[o[p]]);
	            if (smn >= 0)
	              {
	                i++;
	                stack[i] = p;
	                inside[p] = 1;
	              }
	            else
	              {
	                inside[stack[i]] = 0;
	                i--;
	              }
	          }
        }
    }

for (j = 1; j <= N; j++)
  xo[j] = x[o[stack[j]]], yo[j] = y[o[stack[j]]];


/* calculeaza cu cat creste aria prin mutarea fiecarui par */

xo[0] = xo[N], yo[0] = yo[N];
xo[N+1] = xo[1], yo[N+1] = yo[1];

for (i = 1; i <= N; i++)
  v[i] = dist2d(xo[i-1], yo[i-1], xo[i+1], yo[i+1]) * d[o[stack[i]]] / 2.0;

/* Programare Dinamica */

/* step 1 - N nu e folosit */

max[1][0] = 0;
max[1][1] = v[1];

for (i = 2; i < N; i++)
  {
    max[i][1] = v[i] + max[i-1][0];
    max[i][0] = maxim(max[i-1][1], max[i-1][0]);
  }

best1 = maxim(max[N-1][0], max[N-1][1]);

/* step 2 - 1 nu e folosit */

max[2][0] = 0;
max[2][1] = v[2];

for (i = 3; i <= N; i++)
  {
    max[i][1] = v[i] + max[i-1][0];
    max[i][0] = maxim(max[i-1][1], max[i-1][0]);
  }

best2 = maxim(max[N][0], max[N][1]);

/* afisaza rezultatele */
freopen(fileout, "w", stdout);
printf("%.3lf\n", maxim(best1, best2));

return 0;
}