/* Radu Berinde */

#include <stdio.h>
#include <assert.h>

#define Size 524288

int N, C, M, Len[Size];
unsigned char Col[Size][2]; /* Col[x][0] - block color,
                               Col[x][1] - inheritance color */
void join(int pos)
{
    assert(pos < N);
    assert(pos + Len[pos] < N);
    assert(pos + Len[pos] + Len[pos + Len[pos]] <= N);
    Col[pos][0] = Col[pos][1], Col[pos][1] = Col[pos + Len[pos]][1];
    Len[pos] += Len[pos + Len[pos]];
}

void split(int pos, int l, int cl, int cr)
{
    assert(pos < N);
    assert(pos + Len[pos] <= N);
    assert(Len[pos] > l);
    assert(l > 0);
    Col[pos + l][1] = Col[pos][1], Col[pos][1] = Col[pos][0];
    Col[pos][0] = cl, Col[pos + l][0] = cr;
    Len[pos + l] = Len[pos] - l, Len[pos] = l;
}

void read_and_solve()
{
    int cmd, pos, l, cl, cr;
    FILE *fi = fopen("culori.in", "rt");
    FILE *fo = fopen("culori.out", "wt");
    fscanf(fi, "%d %d %d", &N, &C, &M);
    Len[0] = N, Col[0][0] = C, Col[0][1] = 0;
    while (M--)
    {
        fscanf(fi, "%d %d", &cmd, &pos);
        switch (cmd)
        {
            case 0: fprintf(fo, "%d\n", Col[pos][0]);
                    break;
            case 1: join(pos);
                    break;
            case 2: fscanf(fi, "%d %d %d", &l, &cl, &cr);
                    split(pos, l, cl, cr);
                    break;
        }
    }
    fclose(fi);
    fclose(fo);
}

int main()
{
    read_and_solve();
    return 0;
}
