#include <stdio.h>
#define InFile "hof.in"
#define OutFile "hof.out"

typedef unsigned long long uint64;

typedef struct {
  uint64 value;
  uint64 inc;
} pair;

pair series[100];

void init_all_series(void)
{
  int i;
  pair initial_pair = { 3, 4 }; // pregenerate the first three terms
  for (i = 0; i < 99; series[i++] = initial_pair);
}

void generate(int k);

inline int test(int k, unsigned number) {
  switch (number) {
    case 1: case 3: case 7: return 1;
    case 2: case 4: case 5: case 6: return 0;
    default:
      while (series[k].value < number) generate(k);
      return (series[k].value == number);
  }
}

inline void generate(int k) {
  series[k].value += series[k].inc;
  if (test(k+1, ++series[k].inc)) series[k].inc++;
}

int main(void) {
  long int x, k;
  FILE *fin, *fout;
  init_all_series();
  fin=fopen(InFile,"r");
  fscanf(fin,"%ld", &x); // Enter the index
  fclose(fin);
  fout=fopen(OutFile,"w");
  switch (x) {
    case 1: fprintf(fout,"1\n"); break;
    case 2: fprintf(fout,"3\n"); break;
    case 3: fprintf(fout,"7\n"); break;
    default:
      for (k = 3; k <= x; k++) generate(0);
      fprintf(fout,"%llu\n", series[0].value); // print the x'th term
  }
  fclose(fout);
  return 0;
}
