#include <stdio.h>
#include <stdlib.h>
#define NMax 10000
#define InFile "jungla.in"
#define OutFile "jungla.out"
#define Infinit NMax+10

typedef struct lista
        {int nr;/*the number of nodes in the adjacency list */
         int *l;/*pointer to the adjacency list */
        } lista;
typedef lista graph[NMax]; /*the graph represented as adjacency list */
int n, caz, bffound; /*the number of nodes*/
long int m;
graph G;
int d[NMax], p[NMax], o[NMax], r[NMax];
/*d[v]=the distance of v from a, the root of the BFS ;
  d[v]=Infinit if v has not yet been discovered*/
/*p[v]=the parent of v in the BFS tree;
  p[v]=0 if v=a, or v has not yet been discovered;
  if p[v]!=0 then d[v]=1+d[p[v]] */
/*o[v]=the match of v; if o[v]!=0 then o[v] is a vertex in the same level of v
  such that (v,o[v]) is an edge. A vertex is said to be matched if o[v]!=0.
  If v is matched then o[v] is also matched and o[o[v]]=v.*/
/*r[v]=the highest proper ancestor of v in the BFS treee that is matched;
  if v has no matched proper ancestors, then r[v]=0; */
int C[NMax], B, E;
/*C implements the queue; B is the beginning, and E is the end of the queue */
int Cycle[NMax], P;
/*the current even length cycle; P represents its length */
int MinCycle[NMax], Pmin=Infinit;
/*the shortest even length cycle; Pmin represents its length */
int changes=0,bf=0;
void read(void);
void init(int);
int BFS(int);
void write_solution(void);
void determine_cycle1(int, int);
void determine_cycle2(int, int);
void determine_cycle3(int, int);

int main(void)
{
int a, found,i;
read();
for (a=1; a<=n; a++)
     {found=BFS(a);bf++;
      if (found)
         if (P<Pmin)
            {Pmin=P; changes++; bffound=bf-1; caz=found;
             for (i=0; i<P; i++) MinCycle[i]=Cycle[i];     }
     }
if (Pmin==Infinit) printf("Error! No even cycle was found ! \n");
write_solution();
return 0;
}

void read(void)
{ FILE *in;
  long int i;
  int x, y;
  in=fopen(InFile,"r");
  fscanf(in,"%d",&n);
  fscanf(in,"%ld",&m);
  for (i=1; i<=n; i++) {G[i].l=NULL;G[i].nr=0;}
  for (i=1;i<=m;i++)
      {fscanf(in,"%d %d",&x,&y);
       G[x].nr++;
       G[x].l=realloc(G[x].l,G[x].nr*sizeof(int));
       G[x].l[G[x].nr-1]=y;
       G[y].nr++;
       G[y].l=realloc(G[y].l,G[y].nr*sizeof(int));
       G[y].l[G[y].nr-1]=x;
      }
  fclose(in);
}

void init(int a)
{int i;
for (i=1; i<=n; i++)
    {d[i]=Infinit;
     p[i]=o[i]=r[i]=0;}
d[a]=0;
C[0]=a; B=E=0;
}

int BFS(int a)
{ int i, v, u;
  init(a);
  while (B<=E)
        {v=C[B++];
         if (d[v]>Pmin+2) return 0;
         for (i=0; i<G[v].nr; i++)
             {u=G[v].l[i];
              if (d[u]==d[v]-1) continue;
              if (d[u]==Infinit)
                 {d[u]=1+d[v]; p[u]=v;
                  C[++E]=u;
                  continue;}
              if (d[u]==d[v]+1)
                 { /*an even cycle was found */
                   determine_cycle1(v,u);  return 1;       }
              if (d[u]==d[v] && o[v]==u) continue;
              if (d[u]==d[v] && o[v]+o[u])
                 /*o[v]!=u and are not both zero */
                 {/* an even cycle was found */
                  determine_cycle2(v,u);  return 2;        }
              if (d[u]==d[v] && !o[u] && !o[v])
                 /*o[v]=o[u]==0  */
                 if (r[v]==r[u])
                    {o[u]=v; o[v]=u;}
                    else
                    { /*an even cycle was found */
                     determine_cycle3(v,u); return 3;     }
          }
      for (i=0; i<G[v].nr; i++)
          {u=G[v].l[i];
           if (p[u]==v)
              if (!r[v] && o[v]) r[u]=v;
                  else r[u]=r[v];
          }
      }
return 0;
}
void determine_cycle1(int v, int u)
{
/*determine the lowest common ancestor of v and u */
int c1=v, c2=p[u], lg=1, i;
int P1[NMax/2], P2[NMax/2];
P1[0]=v; P2[0]=u; P2[1]=p[u];
while (c1!=c2)
      {c1=p[c1]; P1[lg]=c1;
       c2=p[c2]; P2[++lg]=c2;}
for (i=0; i<lg; i++)
    {Cycle[i]=P1[lg-i-1];
     Cycle[i+lg]=P2[i];}
P=2*lg;
}

void determine_cycle2(int v, int u)
{
int x, aux;
int c1, c2, lg=1, i, j;
int P1[NMax/2], P2[NMax/2];
if (o[u]) {aux=u; u=v;v=aux;}
x=o[v];
if (!x) {printf("error in determine 2\n"); return;}
c1=x; c2=u;
/*determine the lowest common ancestor of x and u */
P1[0]=x; P2[0]=u;
while (c1!=c2)
      {c1=p[c1]; P1[lg]=c1;
       c2=p[c2]; P2[lg++]=c2;}
Cycle[0]=v;
for (i=1; i<=lg; i++)
    Cycle[i]=P1[i-1];
for (j=lg-2; j>=0; j--, i++)
     Cycle[i]=P2[j];
P=i;
}

void determine_cycle3(int v, int u)
{
int c1, c2, lg1=1,lg2, i, lvx, aux, x, y, j, pozx,pozy,xx,yy,dlca,lg;
int P1[NMax/2], P2[NMax/2];
if (r[u]) {aux=u; u=v; v=aux;}
x=r[v]; y=o[x];
if (!x || !y) {printf("error in determine 3\n");return ;}
/*determine the lowest common ancestor of y and u */
P1[0]=y; P2[0]=u;
c1=y; c2=u;
lg1=1; lg2=1;
while (p[c1]) {c1=p[c1];P1[lg1++]=c1;}
while (p[c2]) {c2=p[c2];P2[lg2++]=c2;}
dlca=-1;
for (xx=0; xx<lg1; xx++)
    for (yy=0; yy<lg2; yy++)
        if (P1[xx]==P2[yy] && dlca<d[P1[xx]])
           {dlca=d[P1[xx]];pozx=xx;pozy=yy;}

for (i=0; i<=pozx; i++) Cycle[i]=P1[pozx-i];
lg=pozx+1;
/*determine the path from v to x */
P1[0]=v;lvx=0;
while (P1[lvx]!=x) {P1[lvx+1]=p[P1[lvx]]; lvx++;}
for (j=lvx; j>=0; j--)
    Cycle[lg++]=P1[j];
Cycle[lg++]=u;
for (j=1; j<pozy; j++)
    Cycle[lg++]=P2[j];
P=lg;
}

void write_solution()
{
FILE *out;
int i;
out=fopen(OutFile,"w");
fprintf(out,"%d\n",Pmin);
for (i=0; i<Pmin-1; i++)
    fprintf(out,"%d ",MinCycle[i]);
fprintf(out,"%d\n",MinCycle[Pmin-1]);
fclose(out);
}
