/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* Time Complexity: O(N*(N+M)) */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define filein "jungle.in"
#define fileout "jungle.out"
#define maxn 5001
#define maxm 8001
#define infinit 1000000

long c1[2*maxm],c2[2*maxm],next[2*maxm],e1[maxm],e2[maxm];
long edge[maxn],deg[maxn],ok[maxn],q[2*maxn],tip[2*maxn];
long d[maxn][2],rt[maxn][2],cycle[2*maxn],cact[maxn],tata[maxn][2];
long touch[maxn];
long n,m,nel;

void readdata(void);
void compute(void);
void writedata(void);

int main()
{
readdata();
compute();
writedata();
return 0;
}

void readdata(void)
{
long i,j,k,mm;

freopen(filein,"r",stdin);
scanf("%ld %ld",&n,&m);

memset(edge,0,sizeof(edge));
memset(next,0,sizeof(next));
memset(deg,0,sizeof(deg));
memset(c1,0,sizeof(c1));
memset(c2,0,sizeof(c2));
memset(e1,0,sizeof(e1));
memset(e2,0,sizeof(e2));

for (mm=0,k=1;k<=m;k++)
  {
  scanf("%ld %ld",&i,&j);

  mm++;
  c1[mm]=i; c2[mm]=j;
  next[mm]=edge[i];
  edge[i]=mm;

  mm++;
  c1[mm]=j; c2[mm]=i;
  next[mm]=edge[j];
  edge[j]=mm;

  e1[k]=i;
  e2[k]=j;

  deg[i]++;
  deg[j]++;
  }
}

void compute(void)
{
long i,j,k,ant,p,tipp,root,po,nq,newnel,ntry,okcycle;

for (i=1;i<=n;i++)
  ok[i]=1;

memset(touch,0,sizeof(touch));
for (ntry=0,nel=n+1,root=1;root<=n;root++)
  {
  if (deg[root]>1)
    {
    /* BF from node #root */
    memset(tata,0,sizeof(tata));
    
    /*
    for (i=1;i<=n;i++)
      for (j=0;j<2;j++)
        d[i][j]=infinit;
    */

    memset(d,31,sizeof(d));

    d[root][0]=0;
    q[1]=root;
    tip[1]=0;
    po=nq=1;
    while (po<=nq)
      {
      i=q[po];
      j=tip[po];
  
      k=ant=edge[i];
      while (k>0)
        {
        p=c2[k];
        if (ok[p])
          {
          if (d[p][1-j]>=infinit)
            {
            d[p][1-j]=d[i][j]+1;
            tata[p][1-j]=i;

            nq++;
            q[nq]=p;
            tip[nq]=1-j;
  
            if (i==root)
              rt[p][1-j]=p;
            else
              rt[p][1-j]=rt[i][j];
            }
  
          ant=k;
          k=next[k];
          }
        else
          {
          if (ant!=k)
            {
            next[ant]=next[k];
            k=next[k];
            }
          else
            {
            ant=k=next[k];
            edge[i]=k;
            }
          }
        }
  
      po++;
      }

    /* search for an even-length cycle */
    for (k=1;k<=m;k++)
      {
      i=e1[k];
      j=e2[k];

      if (ok[i] && ok[j] && i!=root && j!=root)
        {
        if (d[i][0]+d[j][1]+1<nel && rt[i][0]!=rt[j][1])
          {
          newnel=d[i][0]+d[j][1]+1;
          ntry++;
          okcycle=1;

          p=i; tipp=ant=0;
          while (p!=root || tipp==1)
            {
            ant++;
            cact[ant]=p;
            if (touch[p]==ntry)
              okcycle=0;

            touch[p]=ntry;
            
            p=tata[p][tipp];
            tipp=1-tipp;
            }

          ant++;
          cact[ant]=root;
          if (touch[root]==ntry)
            okcycle=0;
          touch[root]=ntry;

          ant=newnel+1;
          p=j; tipp=1;
          while (p!=root || tipp==1)
            {
            ant--;
            cact[ant]=p;
            if (touch[p]==ntry)
              okcycle=0;

            touch[p]=ntry;
            p=tata[p][tipp];
            tipp=1-tipp;
            }

          if (okcycle)
            {
            nel=newnel;
            for (p=1;p<=nel;p++)
              cycle[p]=cact[p];
            }

          if (nel==4)
            writedata();
          }

        if (d[i][1]+d[j][0]+1<nel && rt[i][1]!=rt[j][0])
          {
          newnel=d[i][1]+d[j][0]+1;
          ntry++;
          okcycle=1;

          p=i; tipp=1; ant=0;
          while (p!=root || tipp==1)
            {
            ant++;
            cact[ant]=p;
            if (touch[p]==ntry)
              okcycle=0;

            touch[p]=ntry;
            
            p=tata[p][tipp];
            tipp=1-tipp;
            }

          ant++;
          cact[ant]=root;
          if (touch[root]==ntry)
            okcycle=0;
          touch[root]=ntry;

          ant=newnel+1;
          p=j; tipp=0;
          while (p!=root || tipp==1)
            {
            ant--;
            cact[ant]=p;
            if (touch[p]==ntry)
              okcycle=0;

            touch[p]=ntry;
            p=tata[p][tipp];
            tipp=1-tipp;
            }

          if (okcycle)
            {
            nel=newnel;
            for (p=1;p<=nel;p++)
              cycle[p]=cact[p];
            }

          if (nel==4)
            writedata();
          }

        }
      }
    }

  ok[root]=0;
  }
}

void writedata(void)
{
long i;

freopen(fileout,"w",stdout);
printf("%ld\n",nel);
for (i=1;i<=nel;i++)
  printf("%ld ",cycle[i]);

exit(0);
}

