/* Sea2 O(N + M*sqrtN) = O(NsqrtN) solution by Berinde Radu */

#include <stdio.h>
#include <stdlib.h>

#define SQRT 525

int Y[260008], Y2[SQRT];
int Nr[260008], TNr[260008], Tzero[SQRT], Nr2[SQRT];
int Totnr;
int T;

#define Gety(x) (Y[x] > Y2[(x)/SQRT] ? Y[x] : Y2[(x)/SQRT])

void zero(int a, int b)
{
     for (; a <= b && a % SQRT != 0; a++)
         if (Nr[a] && TNr[a] > Tzero[a/SQRT])
             Nr2[a/SQRT]--, Totnr--, Nr[a] = 0, TNr[a] = T;
     for (; a <= b && b % SQRT != SQRT-1; b--)
         if (Nr[b] && TNr[b] > Tzero[b/SQRT])
             Nr2[b/SQRT]--, Totnr--, Nr[b] = 0, TNr[b] = T;
     for (; a < b; a += SQRT)
         Totnr -= Nr2[a/SQRT], Tzero[a/SQRT] = T, Nr2[a/SQRT] = 0;
}

void baga(int pos)
{
    Nr2[pos/SQRT]++, Totnr++;
    Nr[pos] = 1;
    TNr[pos] = T;
}

void sety(int a, int b, int y)
{
    for (; a <= b && a % SQRT != 0; a++) Y[a] = y;
    for (; a <= b && b % SQRT != SQRT-1; b--) Y[b] = y;
    for (; a < b; a += SQRT) Y2[a/SQRT] = y;
}

int point(int x, int y)
{
    int l, r, m;
    if (Gety(x) >= y) return -1;
    for (l = 0, r = x; l < r; )
    if (Gety(m = (l+r)/2) >= y)
        l = m+1;
    else
        r = m;
    T++;
    zero(l, x);
    T++;
    baga(x);
    sety(l, x, y);
    return Totnr;
}

void read_and_solve()
{
    FILE *fi = fopen("sea2.in", "rt");
    FILE *fo = fopen("sea2.out", "wt");
    int x, y, nr;

    fscanf(fi, "%d", &nr);
    while (nr--)
    {
        fscanf(fi, "%d %d", &x, &y);
        fprintf(fo, "%d\n", point(x, y));
    }
    fclose(fo);
    fclose(fi);
}

int main()
{
    read_and_solve();
    return 0;
}
